/* Filter.c generated by valac 0.38.8, the Vala compiler
 * generated from Filter.vala, do not modify */

/* Copyright 2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>


#define TYPE_FILTER (filter_get_type ())
#define FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILTER, Filter))
#define FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILTER, FilterClass))
#define IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILTER))
#define IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILTER))
#define FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILTER, FilterClass))

typedef struct _Filter Filter;
typedef struct _FilterClass FilterClass;
typedef struct _FilterPrivate FilterPrivate;
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DRAG_LIST_ROW (drag_list_row_get_type ())
#define DRAG_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAG_LIST_ROW, DragListRow))
#define DRAG_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAG_LIST_ROW, DragListRowClass))
#define IS_DRAG_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAG_LIST_ROW))
#define IS_DRAG_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAG_LIST_ROW))
#define DRAG_LIST_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAG_LIST_ROW, DragListRowClass))

typedef struct _DragListRow DragListRow;
typedef struct _DragListRowClass DragListRowClass;

#define TYPE_TASK_ROW (task_row_get_type ())
#define TASK_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TASK_ROW, TaskRow))
#define TASK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TASK_ROW, TaskRowClass))
#define IS_TASK_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TASK_ROW))
#define IS_TASK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TASK_ROW))
#define TASK_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TASK_ROW, TaskRowClass))

typedef struct _TaskRow TaskRow;
typedef struct _TaskRowClass TaskRowClass;

#define TYPE_TODO_TASK (todo_task_get_type ())
#define TODO_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TODO_TASK, TodoTask))
#define TODO_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TODO_TASK, TodoTaskClass))
#define IS_TODO_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TODO_TASK))
#define IS_TODO_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TODO_TASK))
#define TODO_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TODO_TASK, TodoTaskClass))

typedef struct _TodoTask TodoTask;
typedef struct _TodoTaskClass TodoTaskClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecFilter ParamSpecFilter;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Filter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FilterPrivate * priv;
};

struct _FilterClass {
	GTypeClass parent_class;
	void (*finalize) (Filter *self);
};

struct _FilterPrivate {
	GList* tags;
	GList* sentence_pieces;
};

struct _ParamSpecFilter {
	GParamSpec parent_instance;
};


static gpointer filter_parent_class = NULL;

gpointer filter_ref (gpointer instance);
void filter_unref (gpointer instance);
GParamSpec* param_spec_filter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_filter (GValue* value, gpointer v_object);
void value_take_filter (GValue* value, gpointer v_object);
gpointer value_get_filter (const GValue* value);
GType filter_get_type (void) G_GNUC_CONST;
#define FILTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_FILTER, FilterPrivate))
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
Filter* filter_new (void);
Filter* filter_construct (GType object_type);
void filter_parse (Filter* self, const gchar* filter_string);
static void filter_add_sentence_piece (Filter* self, const gchar* sentence_piece);
static gboolean filter_contains_tag (Filter* self, const gchar* title, const gchar* filter_string);
GType drag_list_row_get_type (void) G_GNUC_CONST;
gboolean filter_filter (Filter* self, DragListRow* _row);
GType task_row_get_type (void) G_GNUC_CONST;
GType todo_task_get_type (void) G_GNUC_CONST;
TodoTask* task_row_get_task (TaskRow* self);
const gchar* todo_task_get_title (TodoTask* self);
static void filter_finalize (Filter * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void _g_free0_ (gpointer var) {
#line 19 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	var = (g_free (var), NULL);
#line 133 "Filter.c"
}


static inline void _g_list_free__g_free0_ (GList* self) {
#line 19 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 140 "Filter.c"
}


Filter* filter_construct (GType object_type) {
	Filter* self = NULL;
#line 22 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self = (Filter*) g_type_create_instance (object_type);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	__g_list_free__g_free0_0 (self->priv->tags);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self->priv->tags = NULL;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	__g_list_free__g_free0_0 (self->priv->sentence_pieces);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self->priv->sentence_pieces = NULL;
#line 22 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return self;
#line 158 "Filter.c"
}


Filter* filter_new (void) {
#line 22 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return filter_construct (TYPE_FILTER);
#line 165 "Filter.c"
}


void filter_parse (Filter* self, const gchar* filter_string) {
	gchar* sentence_piece = NULL;
	gchar* _tmp0_;
	gchar** parts = NULL;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp50_;
#line 27 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_if_fail (self != NULL);
#line 27 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_if_fail (filter_string != NULL);
#line 28 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	__g_list_free__g_free0_0 (self->priv->tags);
#line 28 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self->priv->tags = NULL;
#line 29 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	__g_list_free__g_free0_0 (self->priv->sentence_pieces);
#line 29 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self->priv->sentence_pieces = NULL;
#line 31 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp0_ = g_strdup ("");
#line 31 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	sentence_piece = _tmp0_;
#line 33 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp1_ = filter_string;
#line 33 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, " ", 0);
#line 33 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	parts = _tmp3_;
#line 33 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	parts_length1 = _vala_array_length (_tmp2_);
#line 33 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_parts_size_ = parts_length1;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp4_ = parts;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp4__length1 = parts_length1;
#line 211 "Filter.c"
	{
		gchar** part_collection = NULL;
		gint part_collection_length1 = 0;
		gint _part_collection_size_ = 0;
		gint part_it = 0;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		part_collection = _tmp4_;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		part_collection_length1 = _tmp4__length1;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		for (part_it = 0; part_it < _tmp4__length1; part_it = part_it + 1) {
#line 223 "Filter.c"
			gchar* _tmp5_;
			gchar* part = NULL;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp5_ = g_strdup (part_collection[part_it]);
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			part = _tmp5_;
#line 230 "Filter.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp6_ = part;
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				if (g_strcmp0 (_tmp6_, "") == 0) {
#line 37 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_g_free0 (part);
#line 37 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					continue;
#line 246 "Filter.c"
				}
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp7_ = part;
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp8_ = g_strconcat (_ ("project"), ":", NULL);
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp9_ = _tmp8_;
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp10_ = g_str_has_prefix (_tmp7_, _tmp9_);
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp11_ = _tmp10_;
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_g_free0 (_tmp9_);
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				if (_tmp11_) {
#line 262 "Filter.c"
					gchar* project = NULL;
					const gchar* _tmp12_;
					gchar** _tmp13_;
					gchar** _tmp14_;
					gchar** _tmp15_;
					gint _tmp15__length1;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gboolean _tmp19_ = FALSE;
					const gchar* _tmp20_;
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp12_ = part;
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp14_ = _tmp13_ = g_strsplit (_tmp12_, ":", 2);
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp15_ = _tmp14_;
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp15__length1 = _vala_array_length (_tmp13_);
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp16_ = _tmp15_[1];
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp17_ = g_strdup (_tmp16_);
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp18_ = _tmp17_;
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					project = _tmp18_;
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp20_ = project;
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					if (_tmp20_ != NULL) {
#line 296 "Filter.c"
						const gchar* _tmp21_;
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp21_ = project;
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp19_ = g_strcmp0 (_tmp21_, "") != 0;
#line 302 "Filter.c"
					} else {
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp19_ = FALSE;
#line 306 "Filter.c"
					}
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					if (_tmp19_) {
#line 310 "Filter.c"
						const gchar* _tmp22_;
						gchar* _tmp23_;
						const gchar* _tmp24_;
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp22_ = project;
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp23_ = g_strconcat ("+", _tmp22_, NULL);
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						self->priv->tags = g_list_prepend (self->priv->tags, _tmp23_);
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp24_ = sentence_piece;
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						filter_add_sentence_piece (self, _tmp24_);
#line 324 "Filter.c"
					}
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_g_free0 (project);
#line 328 "Filter.c"
				} else {
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gboolean _tmp28_;
					gboolean _tmp29_;
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp25_ = part;
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp26_ = g_strconcat (_ ("context"), ":", NULL);
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp27_ = _tmp26_;
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp28_ = g_str_has_prefix (_tmp25_, _tmp27_);
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_tmp29_ = _tmp28_;
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_g_free0 (_tmp27_);
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					if (_tmp29_) {
#line 349 "Filter.c"
						gchar* context = NULL;
						const gchar* _tmp30_;
						gchar** _tmp31_;
						gchar** _tmp32_;
						gchar** _tmp33_;
						gint _tmp33__length1;
						const gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						gboolean _tmp37_ = FALSE;
						const gchar* _tmp38_;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp30_ = part;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp32_ = _tmp31_ = g_strsplit (_tmp30_, ":", 2);
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp33_ = _tmp32_;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp33__length1 = _vala_array_length (_tmp31_);
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp34_ = _tmp33_[1];
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp35_ = g_strdup (_tmp34_);
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp36_ = _tmp35_;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp33_ = (_vala_array_free (_tmp33_, _tmp33__length1, (GDestroyNotify) g_free), NULL);
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						context = _tmp36_;
#line 47 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp38_ = context;
#line 47 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						if (_tmp38_ != NULL) {
#line 383 "Filter.c"
							const gchar* _tmp39_;
#line 47 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
							_tmp39_ = context;
#line 47 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
							_tmp37_ = g_strcmp0 (_tmp39_, "") != 0;
#line 389 "Filter.c"
						} else {
#line 47 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
							_tmp37_ = FALSE;
#line 393 "Filter.c"
						}
#line 47 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						if (_tmp37_) {
#line 397 "Filter.c"
							const gchar* _tmp40_;
							gchar* _tmp41_;
							const gchar* _tmp42_;
#line 48 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
							_tmp40_ = context;
#line 48 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
							_tmp41_ = g_strconcat ("@", _tmp40_, NULL);
#line 48 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
							self->priv->tags = g_list_prepend (self->priv->tags, _tmp41_);
#line 49 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
							_tmp42_ = sentence_piece;
#line 49 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
							filter_add_sentence_piece (self, _tmp42_);
#line 411 "Filter.c"
						}
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_g_free0 (context);
#line 415 "Filter.c"
					} else {
						const gchar* _tmp43_;
						const gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						gchar* _tmp48_;
						gchar* _tmp49_;
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp43_ = sentence_piece;
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp44_ = part;
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp45_ = g_utf8_casefold (_tmp44_, (gssize) -1);
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp46_ = _tmp45_;
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp47_ = g_strconcat (" ", _tmp46_, NULL);
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp48_ = _tmp47_;
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_tmp49_ = g_strconcat (_tmp43_, _tmp48_, NULL);
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_g_free0 (sentence_piece);
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						sentence_piece = _tmp49_;
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_g_free0 (_tmp48_);
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
						_g_free0 (_tmp46_);
#line 446 "Filter.c"
					}
				}
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_g_free0 (part);
#line 451 "Filter.c"
			}
		}
	}
#line 55 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp50_ = sentence_piece;
#line 55 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	filter_add_sentence_piece (self, _tmp50_);
#line 27 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 27 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_g_free0 (sentence_piece);
#line 463 "Filter.c"
}


static gchar* string_chug (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1234 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1235 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1235 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1236 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1236 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_strchug (_tmp1_);
#line 1237 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _result_;
#line 1237 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 486 "Filter.c"
}


static void filter_add_sentence_piece (Filter* self, const gchar* sentence_piece) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 58 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_if_fail (self != NULL);
#line 58 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_if_fail (sentence_piece != NULL);
#line 59 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp0_ = sentence_piece;
#line 59 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (g_strcmp0 (_tmp0_, "") == 0) {
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		return;
#line 504 "Filter.c"
	}
#line 63 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp1_ = sentence_piece;
#line 63 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp2_ = string_chug (_tmp1_);
#line 63 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self->priv->sentence_pieces = g_list_prepend (self->priv->sentence_pieces, _tmp2_);
#line 512 "Filter.c"
}


/**
     * Checks if filter_string is a substring with the following extra
     * properties: if title doesn't start with filter_string a space must
     * preceed it, and if title doesn't end with it a space must succeed it.
     */
static gint string_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1019 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1019 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1020 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 1020 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = needle;
#line 1020 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp2_ = strstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
#line 1020 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1022 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 1022 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 544 "Filter.c"
		gchar* _tmp4_;
#line 1023 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 1023 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 1023 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 552 "Filter.c"
	} else {
#line 1025 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = -1;
#line 1025 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 558 "Filter.c"
	}
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1118 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1119 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1119 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1119 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1119 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 577 "Filter.c"
}


static gboolean filter_contains_tag (Filter* self, const gchar* title, const gchar* filter_string) {
	gboolean result = FALSE;
	gint index = 0;
	gint title_length = 0;
	gint search_length = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 71 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_val_if_fail (title != NULL, FALSE);
#line 71 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_val_if_fail (filter_string != NULL, FALSE);
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp0_ = title;
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp1_ = filter_string;
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp2_ = string_index_of (_tmp0_, _tmp1_, 0);
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	index = _tmp2_;
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp3_ = index;
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (_tmp3_ >= 0) {
#line 608 "Filter.c"
		gint _tmp4_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 77 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp4_ = index;
#line 77 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		if (_tmp4_ > 0) {
#line 623 "Filter.c"
			const gchar* _tmp5_;
			gint _tmp6_;
			gchar _tmp7_;
#line 78 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp5_ = title;
#line 78 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp6_ = index;
#line 78 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp7_ = string_get (_tmp5_, (glong) (_tmp6_ - 1));
#line 78 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			if (_tmp7_ != ' ') {
#line 79 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				result = FALSE;
#line 79 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				return result;
#line 639 "Filter.c"
			}
		}
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp8_ = title;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp9_ = strlen (_tmp8_);
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp10_ = _tmp9_;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		title_length = _tmp10_;
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp11_ = filter_string;
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp12_ = strlen (_tmp11_);
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp13_ = _tmp12_;
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		search_length = _tmp13_;
#line 84 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp14_ = index;
#line 84 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp15_ = search_length;
#line 84 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		_tmp16_ = title_length;
#line 84 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		if ((_tmp14_ + _tmp15_) < _tmp16_) {
#line 666 "Filter.c"
			const gchar* _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gchar _tmp20_;
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp17_ = title;
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp18_ = index;
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp19_ = search_length;
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp20_ = string_get (_tmp17_, (glong) (_tmp18_ + _tmp19_));
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			result = _tmp20_ == ' ';
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			return result;
#line 683 "Filter.c"
		}
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		result = TRUE;
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		return result;
#line 689 "Filter.c"
	}
#line 89 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	result = FALSE;
#line 89 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return result;
#line 695 "Filter.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 94 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return self ? g_object_ref (self) : NULL;
#line 702 "Filter.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1411 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1412 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 722 "Filter.c"
}


gboolean filter_filter (Filter* self, DragListRow* _row) {
	gboolean result = FALSE;
	TaskRow* row = NULL;
	DragListRow* _tmp0_;
	TaskRow* _tmp1_;
	GList* _tmp2_;
	gchar* title = NULL;
	TaskRow* _tmp11_;
	TodoTask* _tmp12_;
	TodoTask* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GList* _tmp17_;
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_val_if_fail (_row != NULL, FALSE);
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_vala_assert (self != NULL, "this != null");
#line 94 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp0_ = _row;
#line 94 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_TASK_ROW) ? ((TaskRow*) _tmp0_) : NULL);
#line 94 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	row = _tmp1_;
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp2_ = self->priv->tags;
#line 754 "Filter.c"
	{
		GList* tag_collection = NULL;
		GList* tag_it = NULL;
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		tag_collection = _tmp2_;
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		for (tag_it = tag_collection; tag_it != NULL; tag_it = tag_it->next) {
#line 762 "Filter.c"
			gchar* _tmp3_;
			gchar* tag = NULL;
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp3_ = g_strdup ((const gchar*) tag_it->data);
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			tag = _tmp3_;
#line 769 "Filter.c"
			{
				TaskRow* _tmp4_;
				TodoTask* _tmp5_;
				TodoTask* _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gboolean _tmp10_;
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp4_ = row;
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp5_ = task_row_get_task (_tmp4_);
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp6_ = _tmp5_;
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp7_ = todo_task_get_title (_tmp6_);
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp8_ = _tmp7_;
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp9_ = tag;
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp10_ = filter_contains_tag (self, _tmp8_, _tmp9_);
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				if (!_tmp10_) {
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					result = FALSE;
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_g_free0 (tag);
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_g_object_unref0 (row);
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					return result;
#line 802 "Filter.c"
				}
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_g_free0 (tag);
#line 806 "Filter.c"
			}
		}
	}
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp11_ = row;
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp12_ = task_row_get_task (_tmp11_);
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp13_ = _tmp12_;
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp14_ = todo_task_get_title (_tmp13_);
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp15_ = _tmp14_;
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp16_ = g_utf8_casefold (_tmp15_, (gssize) -1);
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	title = _tmp16_;
#line 104 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_tmp17_ = self->priv->sentence_pieces;
#line 826 "Filter.c"
	{
		GList* sentence_piece_collection = NULL;
		GList* sentence_piece_it = NULL;
#line 104 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		sentence_piece_collection = _tmp17_;
#line 104 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		for (sentence_piece_it = sentence_piece_collection; sentence_piece_it != NULL; sentence_piece_it = sentence_piece_it->next) {
#line 834 "Filter.c"
			gchar* _tmp18_;
			gchar* sentence_piece = NULL;
#line 104 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			_tmp18_ = g_strdup ((const gchar*) sentence_piece_it->data);
#line 104 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			sentence_piece = _tmp18_;
#line 841 "Filter.c"
			{
				const gchar* _tmp19_;
				const gchar* _tmp20_;
				gboolean _tmp21_;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp19_ = title;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp20_ = sentence_piece;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_tmp21_ = string_contains (_tmp19_, _tmp20_);
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				if (!_tmp21_) {
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					result = FALSE;
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_g_free0 (sentence_piece);
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_g_free0 (title);
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					_g_object_unref0 (row);
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
					return result;
#line 864 "Filter.c"
				}
#line 104 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
				_g_free0 (sentence_piece);
#line 868 "Filter.c"
			}
		}
	}
#line 110 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	result = TRUE;
#line 110 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_g_free0 (title);
#line 110 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	_g_object_unref0 (row);
#line 110 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return result;
#line 880 "Filter.c"
}


static void value_filter_init (GValue* value) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	value->data[0].v_pointer = NULL;
#line 887 "Filter.c"
}


static void value_filter_free_value (GValue* value) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (value->data[0].v_pointer) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		filter_unref (value->data[0].v_pointer);
#line 896 "Filter.c"
	}
}


static void value_filter_copy_value (const GValue* src_value, GValue* dest_value) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (src_value->data[0].v_pointer) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		dest_value->data[0].v_pointer = filter_ref (src_value->data[0].v_pointer);
#line 906 "Filter.c"
	} else {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 910 "Filter.c"
	}
}


static gpointer value_filter_peek_pointer (const GValue* value) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return value->data[0].v_pointer;
#line 918 "Filter.c"
}


static gchar* value_filter_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (collect_values[0].v_pointer) {
#line 925 "Filter.c"
		Filter * object;
		object = collect_values[0].v_pointer;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 932 "Filter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 936 "Filter.c"
		}
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		value->data[0].v_pointer = filter_ref (object);
#line 940 "Filter.c"
	} else {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		value->data[0].v_pointer = NULL;
#line 944 "Filter.c"
	}
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return NULL;
#line 948 "Filter.c"
}


static gchar* value_filter_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Filter ** object_p;
	object_p = collect_values[0].v_pointer;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (!object_p) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 959 "Filter.c"
	}
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (!value->data[0].v_pointer) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		*object_p = NULL;
#line 965 "Filter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		*object_p = value->data[0].v_pointer;
#line 969 "Filter.c"
	} else {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		*object_p = filter_ref (value->data[0].v_pointer);
#line 973 "Filter.c"
	}
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return NULL;
#line 977 "Filter.c"
}


GParamSpec* param_spec_filter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecFilter* spec;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FILTER), NULL);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return G_PARAM_SPEC (spec);
#line 991 "Filter.c"
}


gpointer value_get_filter (const GValue* value) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILTER), NULL);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return value->data[0].v_pointer;
#line 1000 "Filter.c"
}


void value_set_filter (GValue* value, gpointer v_object) {
	Filter * old;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILTER));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	old = value->data[0].v_pointer;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (v_object) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FILTER));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		value->data[0].v_pointer = v_object;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		filter_ref (value->data[0].v_pointer);
#line 1020 "Filter.c"
	} else {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		value->data[0].v_pointer = NULL;
#line 1024 "Filter.c"
	}
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (old) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		filter_unref (old);
#line 1030 "Filter.c"
	}
}


void value_take_filter (GValue* value, gpointer v_object) {
	Filter * old;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILTER));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	old = value->data[0].v_pointer;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (v_object) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FILTER));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		value->data[0].v_pointer = v_object;
#line 1049 "Filter.c"
	} else {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		value->data[0].v_pointer = NULL;
#line 1053 "Filter.c"
	}
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (old) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		filter_unref (old);
#line 1059 "Filter.c"
	}
}


static void filter_class_init (FilterClass * klass) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	filter_parent_class = g_type_class_peek_parent (klass);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	((FilterClass *) klass)->finalize = filter_finalize;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_type_class_add_private (klass, sizeof (FilterPrivate));
#line 1071 "Filter.c"
}


static void filter_instance_init (Filter * self) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self->priv = FILTER_GET_PRIVATE (self);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self->ref_count = 1;
#line 1080 "Filter.c"
}


static void filter_finalize (Filter * obj) {
	Filter * self;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILTER, Filter);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_signal_handlers_destroy (self);
#line 19 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	__g_list_free__g_free0_0 (self->priv->tags);
#line 20 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	__g_list_free__g_free0_0 (self->priv->sentence_pieces);
#line 1094 "Filter.c"
}


GType filter_get_type (void) {
	static volatile gsize filter_type_id__volatile = 0;
	if (g_once_init_enter (&filter_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_filter_init, value_filter_free_value, value_filter_copy_value, value_filter_peek_pointer, "p", value_filter_collect_value, "p", value_filter_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (FilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Filter), 0, (GInstanceInitFunc) filter_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType filter_type_id;
		filter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Filter", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&filter_type_id__volatile, filter_type_id);
	}
	return filter_type_id__volatile;
}


gpointer filter_ref (gpointer instance) {
	Filter * self;
	self = instance;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	return instance;
#line 1119 "Filter.c"
}


void filter_unref (gpointer instance) {
	Filter * self;
	self = instance;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		FILTER_GET_CLASS (self)->finalize (self);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Filter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1132 "Filter.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



