/* SequentialList.c generated by valac 0.38.8, the Vala compiler
 * generated from SequentialList.vala, do not modify */

/* Copyright 2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SEQUENTIAL_LIST (sequential_list_get_type ())
#define SEQUENTIAL_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEQUENTIAL_LIST, SequentialList))
#define SEQUENTIAL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEQUENTIAL_LIST, SequentialListClass))
#define IS_SEQUENTIAL_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEQUENTIAL_LIST))
#define IS_SEQUENTIAL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEQUENTIAL_LIST))
#define SEQUENTIAL_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEQUENTIAL_LIST, SequentialListClass))

typedef struct _SequentialList SequentialList;
typedef struct _SequentialListClass SequentialListClass;
typedef struct _SequentialListPrivate SequentialListPrivate;
#define __g_queue_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_queue_free__g_object_unref0_ (var), NULL)))
typedef struct _ParamSpecSequentialList ParamSpecSequentialList;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SequentialList {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SequentialListPrivate * priv;
};

struct _SequentialListClass {
	GTypeClass parent_class;
	void (*finalize) (SequentialList *self);
};

struct _SequentialListPrivate {
	GQueue* items;
	GList* iter_link;
	gint iter_link_index;
	GType item_type;
};

struct _ParamSpecSequentialList {
	GParamSpec parent_instance;
};


static gpointer sequential_list_parent_class = NULL;

gpointer sequential_list_ref (gpointer instance);
void sequential_list_unref (gpointer instance);
GParamSpec* param_spec_sequential_list (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_sequential_list (GValue* value, gpointer v_object);
void value_take_sequential_list (GValue* value, gpointer v_object);
gpointer value_get_sequential_list (const GValue* value);
GType sequential_list_get_type (void) G_GNUC_CONST;
#define SEQUENTIAL_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SEQUENTIAL_LIST, SequentialListPrivate))
static void _g_object_unref0_ (gpointer var);
static inline void _g_queue_free__g_object_unref0_ (GQueue* self);
SequentialList* sequential_list_new (GType item_type);
SequentialList* sequential_list_construct (GType object_type, GType item_type);
static void sequential_list_move_iter_link_to_index (SequentialList* self, gint index);
void sequential_list_append_item (SequentialList* self, GObject* item);
guint sequential_list_remove_item (SequentialList* self, GObject* item);
void sequential_list_move_item (SequentialList* self, guint old_position, guint new_position);
GObject* sequential_list_get_item (SequentialList* self, guint position);
GType sequential_list_get_item_type (SequentialList* self);
void sequential_list_clear (SequentialList* self);
guint sequential_list_get_length (SequentialList* self);
static void sequential_list_finalize (SequentialList * obj);


static void _g_object_unref0_ (gpointer var) {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 96 "SequentialList.c"
}


static inline void _g_queue_free__g_object_unref0_ (GQueue* self) {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 103 "SequentialList.c"
}


SequentialList* sequential_list_construct (GType object_type, GType item_type) {
	SequentialList* self = NULL;
	GType _tmp0_;
	GQueue* _tmp1_;
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self = (SequentialList*) g_type_create_instance (object_type);
#line 37 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = item_type;
#line 37 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->item_type = _tmp0_;
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = g_queue_new ();
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	__g_queue_free__g_object_unref0_0 (self->priv->items);
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->items = _tmp1_;
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return self;
#line 127 "SequentialList.c"
}


SequentialList* sequential_list_new (GType item_type) {
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return sequential_list_construct (TYPE_SEQUENTIAL_LIST, item_type);
#line 134 "SequentialList.c"
}


static void sequential_list_move_iter_link_to_index (SequentialList* self, gint index) {
	GList* closest_link = NULL;
	gint distance = 0;
	gint distance_head = 0;
	gint _tmp0_;
	gint distance_tail = 0;
	gint _tmp1_;
	GQueue* _tmp2_;
	guint _tmp3_;
	gint distance_iter = 0;
	gint _tmp4_;
	gint _tmp5_;
	GList* _tmp12_;
	gint _tmp21_;
	gint _tmp29_;
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (self != NULL);
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = index;
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	distance_head = _tmp0_;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = index;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp2_ = self->priv->items;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp3_ = _tmp2_->length;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	distance_tail = (_tmp1_ - ((gint) _tmp3_)) + 1;
#line 49 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp4_ = distance_tail;
#line 49 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp5_ = distance_head;
#line 49 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if ((-_tmp4_) < _tmp5_) {
#line 173 "SequentialList.c"
		GQueue* _tmp6_;
		GList* _tmp7_;
		gint _tmp8_;
#line 50 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp6_ = self->priv->items;
#line 50 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp7_ = _tmp6_->tail;
#line 50 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		closest_link = _tmp7_;
#line 51 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp8_ = distance_tail;
#line 51 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		distance = _tmp8_;
#line 187 "SequentialList.c"
	} else {
		GQueue* _tmp9_;
		GList* _tmp10_;
		gint _tmp11_;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp9_ = self->priv->items;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp10_ = _tmp9_->head;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		closest_link = _tmp10_;
#line 54 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp11_ = distance_head;
#line 54 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		distance = _tmp11_;
#line 202 "SequentialList.c"
	}
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp12_ = self->priv->iter_link;
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (_tmp12_ != NULL) {
#line 208 "SequentialList.c"
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp13_ = index;
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp14_ = self->priv->iter_link_index;
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		distance_iter = _tmp13_ - _tmp14_;
#line 58 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp15_ = distance;
#line 58 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp16_ = abs (_tmp15_);
#line 58 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp17_ = distance_iter;
#line 58 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp18_ = abs (_tmp17_);
#line 58 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		if (_tmp16_ > _tmp18_) {
#line 231 "SequentialList.c"
			gint _tmp19_;
			GList* _tmp20_;
#line 59 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp19_ = distance_iter;
#line 59 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			distance = _tmp19_;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp20_ = self->priv->iter_link;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			closest_link = _tmp20_;
#line 242 "SequentialList.c"
		}
	}
#line 64 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp21_ = distance;
#line 64 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (_tmp21_ > 0) {
#line 249 "SequentialList.c"
		GList* _tmp22_;
		gint _tmp23_;
		GList* _tmp24_;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp22_ = closest_link;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp23_ = distance;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp24_ = g_list_nth (_tmp22_, (guint) _tmp23_);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		self->priv->iter_link = _tmp24_;
#line 261 "SequentialList.c"
	} else {
		GList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		GList* _tmp28_;
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp25_ = closest_link;
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp26_ = distance;
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp27_ = abs (_tmp26_);
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp28_ = g_list_nth_prev (_tmp25_, (guint) _tmp27_);
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		self->priv->iter_link = _tmp28_;
#line 277 "SequentialList.c"
	}
#line 69 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp29_ = index;
#line 69 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link_index = _tmp29_;
#line 283 "SequentialList.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return self ? g_object_ref (self) : NULL;
#line 290 "SequentialList.c"
}


void sequential_list_append_item (SequentialList* self, GObject* item) {
	GQueue* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (self != NULL);
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (item != NULL);
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = item;
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_push_tail (_tmp0_, _tmp2_);
#line 312 "SequentialList.c"
}


guint sequential_list_remove_item (SequentialList* self, GObject* item) {
	guint result = 0U;
	guint i = 0U;
	GList* iter = NULL;
	GQueue* _tmp0_;
	GList* _tmp1_;
	GList* _tmp10_;
	GQueue* _tmp11_;
	GList* _tmp12_;
#line 77 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (item != NULL, 0U);
#line 78 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 79 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	i = (guint) 0;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = _tmp0_->head;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	iter = _tmp1_;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	while (TRUE) {
#line 341 "SequentialList.c"
		gboolean _tmp2_ = FALSE;
		GList* _tmp3_;
		GList* _tmp7_;
		GList* _tmp8_;
		guint _tmp9_;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp3_ = iter;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		if (_tmp3_ != NULL) {
#line 351 "SequentialList.c"
			GList* _tmp4_;
			gconstpointer _tmp5_;
			GObject* _tmp6_;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp4_ = iter;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp5_ = _tmp4_->data;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp6_ = item;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp2_ = ((GObject*) _tmp5_) != _tmp6_;
#line 363 "SequentialList.c"
		} else {
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp2_ = FALSE;
#line 367 "SequentialList.c"
		}
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		if (!_tmp2_) {
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			break;
#line 373 "SequentialList.c"
		}
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp7_ = iter;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp8_ = _tmp7_->next;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		iter = _tmp8_;
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp9_ = i;
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		i = _tmp9_ + 1;
#line 385 "SequentialList.c"
	}
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp10_ = iter;
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_vala_assert (_tmp10_ != NULL, "iter != null");
#line 86 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp11_ = self->priv->items;
#line 86 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp12_ = iter;
#line 86 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_delete_link (_tmp11_, _tmp12_);
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	result = i;
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return result;
#line 401 "SequentialList.c"
}


void sequential_list_move_item (SequentialList* self, guint old_position, guint new_position) {
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	GQueue* _tmp3_;
	GQueue* _tmp4_;
	guint _tmp5_;
	gpointer _tmp6_;
	guint _tmp7_;
#line 90 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (self != NULL);
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = old_position;
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (((gint) _tmp1_) >= 0) {
#line 419 "SequentialList.c"
		guint _tmp2_;
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp2_ = new_position;
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp0_ = ((gint) _tmp2_) >= 0;
#line 425 "SequentialList.c"
	} else {
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp0_ = FALSE;
#line 429 "SequentialList.c"
	}
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_vala_assert (_tmp0_, "((int)old_position) >= 0 && ((int)new_position) >= 0");
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp3_ = self->priv->items;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp4_ = self->priv->items;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp5_ = old_position;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp6_ = g_queue_pop_nth (_tmp4_, _tmp5_);
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp7_ = new_position;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_push_nth (_tmp3_, (GObject*) _tmp6_, (gint) _tmp7_);
#line 447 "SequentialList.c"
}


GObject* sequential_list_get_item (SequentialList* self, guint position) {
	GObject* result = NULL;
	guint _tmp0_;
	guint _tmp1_;
	GQueue* _tmp2_;
	guint _tmp3_;
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = position;
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_vala_assert (((gint) _tmp0_) >= 0, "((int)position) >= 0");
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = position;
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp2_ = self->priv->items;
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp3_ = _tmp2_->length;
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (_tmp1_ < _tmp3_) {
#line 471 "SequentialList.c"
		guint _tmp4_;
		GList* _tmp5_;
		gconstpointer _tmp6_;
		GObject* _tmp7_;
#line 99 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp4_ = position;
#line 99 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_move_iter_link_to_index (self, (gint) _tmp4_);
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp5_ = self->priv->iter_link;
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp6_ = _tmp5_->data;
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp7_ = _g_object_ref0 ((GObject*) _tmp6_);
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		result = _tmp7_;
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		return result;
#line 490 "SequentialList.c"
	}
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	result = NULL;
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return result;
#line 496 "SequentialList.c"
}


GType sequential_list_get_item_type (SequentialList* self) {
	GType result = 0UL;
	GType _tmp0_;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->item_type;
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	result = _tmp0_;
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return result;
#line 511 "SequentialList.c"
}


void sequential_list_clear (SequentialList* self) {
	GQueue* _tmp0_;
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (self != NULL);
#line 110 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 111 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 111 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_clear (_tmp0_);
#line 525 "SequentialList.c"
}


guint sequential_list_get_length (SequentialList* self) {
	guint result;
	GQueue* _tmp0_;
	guint _tmp1_;
#line 31 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 32 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 32 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = _tmp0_->length;
#line 32 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	result = _tmp1_;
#line 32 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return result;
#line 543 "SequentialList.c"
}


static void value_sequential_list_init (GValue* value) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	value->data[0].v_pointer = NULL;
#line 550 "SequentialList.c"
}


static void value_sequential_list_free_value (GValue* value) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (value->data[0].v_pointer) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_unref (value->data[0].v_pointer);
#line 559 "SequentialList.c"
	}
}


static void value_sequential_list_copy_value (const GValue* src_value, GValue* dest_value) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		dest_value->data[0].v_pointer = sequential_list_ref (src_value->data[0].v_pointer);
#line 569 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 573 "SequentialList.c"
	}
}


static gpointer value_sequential_list_peek_pointer (const GValue* value) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return value->data[0].v_pointer;
#line 581 "SequentialList.c"
}


static gchar* value_sequential_list_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (collect_values[0].v_pointer) {
#line 588 "SequentialList.c"
		SequentialList * object;
		object = collect_values[0].v_pointer;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 595 "SequentialList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 599 "SequentialList.c"
		}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = sequential_list_ref (object);
#line 603 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = NULL;
#line 607 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return NULL;
#line 611 "SequentialList.c"
}


static gchar* value_sequential_list_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SequentialList ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (!object_p) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 622 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (!value->data[0].v_pointer) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		*object_p = NULL;
#line 628 "SequentialList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		*object_p = value->data[0].v_pointer;
#line 632 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		*object_p = sequential_list_ref (value->data[0].v_pointer);
#line 636 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return NULL;
#line 640 "SequentialList.c"
}


GParamSpec* param_spec_sequential_list (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSequentialList* spec;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SEQUENTIAL_LIST), NULL);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return G_PARAM_SPEC (spec);
#line 654 "SequentialList.c"
}


gpointer value_get_sequential_list (const GValue* value) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEQUENTIAL_LIST), NULL);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return value->data[0].v_pointer;
#line 663 "SequentialList.c"
}


void value_set_sequential_list (GValue* value, gpointer v_object) {
	SequentialList * old;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEQUENTIAL_LIST));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	old = value->data[0].v_pointer;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (v_object) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEQUENTIAL_LIST));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = v_object;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_ref (value->data[0].v_pointer);
#line 683 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = NULL;
#line 687 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (old) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_unref (old);
#line 693 "SequentialList.c"
	}
}


void value_take_sequential_list (GValue* value, gpointer v_object) {
	SequentialList * old;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEQUENTIAL_LIST));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	old = value->data[0].v_pointer;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (v_object) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEQUENTIAL_LIST));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = v_object;
#line 712 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = NULL;
#line 716 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (old) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_unref (old);
#line 722 "SequentialList.c"
	}
}


static void sequential_list_class_init (SequentialListClass * klass) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	sequential_list_parent_class = g_type_class_peek_parent (klass);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	((SequentialListClass *) klass)->finalize = sequential_list_finalize;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_type_class_add_private (klass, sizeof (SequentialListPrivate));
#line 734 "SequentialList.c"
}


static void sequential_list_instance_init (SequentialList * self) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv = SEQUENTIAL_LIST_GET_PRIVATE (self);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->ref_count = 1;
#line 743 "SequentialList.c"
}


static void sequential_list_finalize (SequentialList * obj) {
	SequentialList * self;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEQUENTIAL_LIST, SequentialList);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_signal_handlers_destroy (self);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	__g_queue_free__g_object_unref0_0 (self->priv->items);
#line 755 "SequentialList.c"
}


/**
 * Data structure used to implement DragListModel.
 * It keeps track of the last accessed link to provide sequential access in O(1).
 * This class doesn't use generics as valac (0.36.7) generated invalid c code 
 * for the code responsible for freeing the internal Queue.
 */
GType sequential_list_get_type (void) {
	static volatile gsize sequential_list_type_id__volatile = 0;
	if (g_once_init_enter (&sequential_list_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_sequential_list_init, value_sequential_list_free_value, value_sequential_list_copy_value, value_sequential_list_peek_pointer, "p", value_sequential_list_collect_value, "p", value_sequential_list_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SequentialListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sequential_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SequentialList), 0, (GInstanceInitFunc) sequential_list_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType sequential_list_type_id;
		sequential_list_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SequentialList", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&sequential_list_type_id__volatile, sequential_list_type_id);
	}
	return sequential_list_type_id__volatile;
}


gpointer sequential_list_ref (gpointer instance) {
	SequentialList * self;
	self = instance;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return instance;
#line 786 "SequentialList.c"
}


void sequential_list_unref (gpointer instance) {
	SequentialList * self;
	self = instance;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		SEQUENTIAL_LIST_GET_CLASS (self)->finalize (self);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 799 "SequentialList.c"
	}
}



