/* SettingsManager.c generated by valac 0.38.8, the Vala compiler
 * generated from SettingsManager.vala, do not modify */

/* Copyright 2014-2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SETTINGS_MANAGER (settings_manager_get_type ())
#define SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SETTINGS_MANAGER, SettingsManager))
#define SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SETTINGS_MANAGER, SettingsManagerClass))
#define IS_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SETTINGS_MANAGER))
#define IS_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SETTINGS_MANAGER))
#define SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SETTINGS_MANAGER, SettingsManagerClass))

typedef struct _SettingsManager SettingsManager;
typedef struct _SettingsManagerClass SettingsManagerClass;
typedef struct _SettingsManagerPrivate SettingsManagerPrivate;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define GOFI_TYPE_FEATURE_STATUS (gofi_feature_status_get_type ())
typedef struct _ParamSpecSettingsManager ParamSpecSettingsManager;
enum  {
	SETTINGS_MANAGER_TODO_TXT_LOCATION_CHANGED_SIGNAL,
	SETTINGS_MANAGER_TIMER_DURATION_CHANGED_SIGNAL,
	SETTINGS_MANAGER_USE_DARK_THEME_CHANGED_SIGNAL,
	SETTINGS_MANAGER_USE_HEADER_BAR_CHANGED_SIGNAL,
	SETTINGS_MANAGER_NUM_SIGNALS
};
static guint settings_manager_signals[SETTINGS_MANAGER_NUM_SIGNALS] = {0};

struct _SettingsManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SettingsManagerPrivate * priv;
	gboolean first_start;
};

struct _SettingsManagerClass {
	GTypeClass parent_class;
	void (*finalize) (SettingsManager *self);
};

struct _SettingsManagerPrivate {
	GKeyFile* key_file;
};

typedef enum  {
	GOFI_FEATURE_STATUS_UNKNOWN,
	GOFI_FEATURE_STATUS_ALWAYS,
	GOFI_FEATURE_STATUS_COMMON,
	GOFI_FEATURE_STATUS_UNCOMMON,
	GOFI_FEATURE_STATUS_NEVER
} GOFIFeatureStatus;

struct _ParamSpecSettingsManager {
	GParamSpec parent_instance;
};


static gpointer settings_manager_parent_class = NULL;

gpointer settings_manager_ref (gpointer instance);
void settings_manager_unref (gpointer instance);
GParamSpec* param_spec_settings_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_settings_manager (GValue* value, gpointer v_object);
void value_take_settings_manager (GValue* value, gpointer v_object);
gpointer value_get_settings_manager (const GValue* value);
GType settings_manager_get_type (void) G_GNUC_CONST;
#define SETTINGS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SETTINGS_MANAGER, SettingsManagerPrivate))
#define SETTINGS_MANAGER_GROUP_TODO_TXT "Todo.txt"
#define SETTINGS_MANAGER_GROUP_TIMER "Timer"
#define SETTINGS_MANAGER_GROUP_UI "Interface"
SettingsManager* settings_manager_new_load_from_key_file (void);
SettingsManager* settings_manager_construct_load_from_key_file (GType object_type);
gchar* gofi_utils_get_config_file (void);
gchar* gofi_utils_get_config_dir (void);
static gboolean settings_manager_import_from_old_path (SettingsManager* self);
static void settings_manager_generate_configuration (SettingsManager* self);
static gchar* settings_manager_header_bar_default (SettingsManager* self);
GType gofi_feature_status_get_type (void) G_GNUC_CONST;
GOFIFeatureStatus gofi_utils_get_desktop_hb_status (void);
gboolean gofi_feature_status_use_feature (GOFIFeatureStatus self, gboolean _default);
static gchar* settings_manager_get_value (SettingsManager* self, const gchar* group, const gchar* key, const gchar* _default_);
static void settings_manager_set_value (SettingsManager* self, const gchar* group, const gchar* key, const gchar* value);
static void settings_manager_write_key_file (SettingsManager* self, GError** error);
void settings_manager_set_todo_txt_location (SettingsManager* self, const gchar* value);
gchar* gofi_utils_get_old_config_file (void);
static void settings_manager_import_group (SettingsManager* self, GKeyFile* old_file, const gchar* group, gchar** keys, int keys_length1, GError** error);
SettingsManager* settings_manager_new (void);
SettingsManager* settings_manager_construct (GType object_type);
gchar* settings_manager_get_todo_txt_location (SettingsManager* self);
gint settings_manager_get_task_duration (SettingsManager* self);
void settings_manager_set_task_duration (SettingsManager* self, gint value);
gint settings_manager_get_break_duration (SettingsManager* self);
void settings_manager_set_break_duration (SettingsManager* self, gint value);
gint settings_manager_get_reminder_time (SettingsManager* self);
void settings_manager_set_reminder_time (SettingsManager* self, gint value);
gboolean settings_manager_get_reminder_active (SettingsManager* self);
gint settings_manager_get_win_x (SettingsManager* self);
void settings_manager_set_win_x (SettingsManager* self, gint value);
gint settings_manager_get_win_y (SettingsManager* self);
void settings_manager_set_win_y (SettingsManager* self, gint value);
gint settings_manager_get_win_width (SettingsManager* self);
void settings_manager_set_win_width (SettingsManager* self, gint value);
gint settings_manager_get_win_height (SettingsManager* self);
void settings_manager_set_win_height (SettingsManager* self, gint value);
gboolean settings_manager_get_use_header_bar (SettingsManager* self);
void settings_manager_set_use_header_bar (SettingsManager* self, gboolean value);
gboolean settings_manager_get_use_dark_theme (SettingsManager* self);
void settings_manager_set_use_dark_theme (SettingsManager* self, gboolean value);
static void settings_manager_finalize (SettingsManager * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

extern const gchar* GOFI_TEST_DIRS[5];

/**
     * Constructs a SettingsManager object from a configuration file.
     * Reads the corresponding file and creates it, if necessary.
     */
SettingsManager* settings_manager_construct_load_from_key_file (GType object_type) {
	SettingsManager* self = NULL;
	GKeyFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GError * _inner_error_ = NULL;
#line 156 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	self = (SettingsManager*) g_type_create_instance (object_type);
#line 158 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = g_key_file_new ();
#line 158 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_key_file_unref0 (self->priv->key_file);
#line 158 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	self->priv->key_file = _tmp0_;
#line 160 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = gofi_utils_get_config_file ();
#line 160 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 160 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp3_ = _tmp2_;
#line 160 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp4_ = g_file_test (_tmp3_, G_FILE_TEST_EXISTS);
#line 160 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp5_ = !_tmp4_;
#line 160 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp3_);
#line 160 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (_tmp5_) {
#line 178 "SettingsManager.c"
		gint dir_exists = 0;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gboolean _tmp15_;
#line 161 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp6_ = gofi_utils_get_config_dir ();
#line 161 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp7_ = _tmp6_;
#line 161 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp8_ = _tmp7_;
#line 161 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp9_ = g_mkdir_with_parents (_tmp8_, 0775);
#line 161 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp10_ = _tmp9_;
#line 161 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_free0 (_tmp8_);
#line 161 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		dir_exists = _tmp10_;
#line 164 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp11_ = dir_exists;
#line 164 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (_tmp11_ != 0) {
#line 205 "SettingsManager.c"
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 165 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp12_ = gofi_utils_get_config_dir ();
#line 165 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp13_ = _tmp12_;
#line 165 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp14_ = _tmp13_;
#line 165 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_error (_ ("Couldn't create directory: %s"), _tmp14_);
#line 165 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_free0 (_tmp14_);
#line 219 "SettingsManager.c"
		}
#line 167 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp15_ = settings_manager_import_from_old_path (self);
#line 167 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (!_tmp15_) {
#line 225 "SettingsManager.c"
			FILE* _tmp16_;
#line 168 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp16_ = stdout;
#line 168 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			fprintf (_tmp16_, "old file not imported\n");
#line 170 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			settings_manager_generate_configuration (self);
#line 171 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			self->first_start = TRUE;
#line 235 "SettingsManager.c"
		}
	} else {
		{
			GKeyFile* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp17_ = self->priv->key_file;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp18_ = gofi_utils_get_config_file ();
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp19_ = _tmp18_;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp20_ = _tmp19_;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_key_file_load_from_file (_tmp17_, _tmp20_, G_KEY_FILE_KEEP_COMMENTS | G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error_);
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_free0 (_tmp20_);
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 257 "SettingsManager.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			FILE* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			const gchar* _tmp25_;
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			e = _inner_error_;
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_inner_error_ = NULL;
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp21_ = stderr;
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp22_ = gofi_utils_get_config_file ();
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp23_ = _tmp22_;
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp24_ = _tmp23_;
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			fprintf (_tmp21_, "Reading %s failed", _tmp24_);
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_free0 (_tmp24_);
#line 180 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp25_ = e->message;
#line 180 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_error ("SettingsManager.vala:180: %s", _tmp25_);
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_error_free0 (e);
#line 292 "SettingsManager.c"
		}
		__finally0:
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_clear_error (&_inner_error_);
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return NULL;
#line 303 "SettingsManager.c"
		}
	}
#line 156 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return self;
#line 308 "SettingsManager.c"
}


SettingsManager* settings_manager_new_load_from_key_file (void) {
#line 156 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return settings_manager_construct_load_from_key_file (TYPE_SETTINGS_MANAGER);
#line 315 "SettingsManager.c"
}


static gchar* settings_manager_header_bar_default (SettingsManager* self) {
	gchar* result = NULL;
	GOFIFeatureStatus _tmp0_;
	GOFIFeatureStatus _tmp1_;
	gboolean _tmp2_;
	gchar* _tmp4_;
#line 185 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 186 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = gofi_utils_get_desktop_hb_status ();
#line 186 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = _tmp0_;
#line 186 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = gofi_feature_status_use_feature (_tmp1_, TRUE);
#line 186 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (_tmp2_) {
#line 335 "SettingsManager.c"
		gchar* _tmp3_;
#line 187 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp3_ = g_strdup ("true");
#line 187 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		result = _tmp3_;
#line 187 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return result;
#line 343 "SettingsManager.c"
	}
#line 189 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp4_ = g_strdup ("false");
#line 189 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp4_;
#line 189 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 351 "SettingsManager.c"
}


/**
     * Provides read access to a setting, given a certain group and key.
     * Public access is granted via the SettingsManager's attributes, so this
     * function has been declared private
     */
static gchar* settings_manager_get_value (SettingsManager* self, const gchar* group, const gchar* key, const gchar* _default_) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 197 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 197 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 197 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 197 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (_default_ != NULL, NULL);
#line 371 "SettingsManager.c"
	{
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		GKeyFile* _tmp2_;
#line 200 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp2_ = self->priv->key_file;
#line 200 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (_tmp2_ != NULL) {
#line 380 "SettingsManager.c"
			GKeyFile* _tmp3_;
			const gchar* _tmp4_;
			gboolean _tmp5_;
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp3_ = self->priv->key_file;
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp4_ = group;
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp5_ = g_key_file_has_group (_tmp3_, _tmp4_);
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp1_ = _tmp5_;
#line 392 "SettingsManager.c"
		} else {
#line 200 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp1_ = FALSE;
#line 396 "SettingsManager.c"
		}
#line 200 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (_tmp1_) {
#line 400 "SettingsManager.c"
			gboolean _tmp6_ = FALSE;
			GKeyFile* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gboolean _tmp10_;
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp7_ = self->priv->key_file;
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp8_ = group;
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp9_ = key;
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp10_ = g_key_file_has_key (_tmp7_, _tmp8_, _tmp9_, &_inner_error_);
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp6_ = _tmp10_;
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 418 "SettingsManager.c"
				goto __catch1_g_error;
			}
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp0_ = _tmp6_;
#line 423 "SettingsManager.c"
		} else {
#line 200 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp0_ = FALSE;
#line 427 "SettingsManager.c"
		}
#line 200 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (_tmp0_) {
#line 431 "SettingsManager.c"
			gchar* _tmp11_ = NULL;
			GKeyFile* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp12_ = self->priv->key_file;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp13_ = group;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp14_ = key;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp15_ = g_key_file_get_value (_tmp12_, _tmp13_, _tmp14_, &_inner_error_);
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp11_ = _tmp15_;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 450 "SettingsManager.c"
				goto __catch1_g_error;
			}
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp16_ = _tmp11_;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp11_ = NULL;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			result = _tmp16_;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_free0 (_tmp11_);
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return result;
#line 463 "SettingsManager.c"
		} else {
			const gchar* _tmp17_;
			gchar* _tmp18_;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp17_ = _default_;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp18_ = g_strdup (_tmp17_);
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			result = _tmp18_;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return result;
#line 475 "SettingsManager.c"
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
#line 198 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		e = _inner_error_;
#line 198 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_inner_error_ = NULL;
#line 208 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp19_ = group;
#line 208 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp20_ = key;
#line 208 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp21_ = e->message;
#line 208 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_error ("An error occured while reading the setting" " %s.%s: %s", _tmp19_, _tmp20_, _tmp21_);
#line 198 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_error_free0 (e);
#line 499 "SettingsManager.c"
	}
	__finally1:
#line 198 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 198 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_clear_error (&_inner_error_);
#line 198 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return NULL;
#line 508 "SettingsManager.c"
}


/**
     * Provides write access to a setting, given a certain group key and value.
     * Public access is granted via the SettingsManager's attributes, so this
     * function has been declared private
     */
static void settings_manager_set_value (SettingsManager* self, const gchar* group, const gchar* key, const gchar* value) {
	GKeyFile* _tmp0_;
	GError * _inner_error_ = NULL;
#line 218 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 218 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (group != NULL);
#line 218 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (key != NULL);
#line 218 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (value != NULL);
#line 219 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = self->priv->key_file;
#line 219 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (_tmp0_ != NULL) {
#line 532 "SettingsManager.c"
		{
			GKeyFile* _tmp1_;
			const gchar* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
#line 221 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp1_ = self->priv->key_file;
#line 221 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp2_ = group;
#line 221 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp3_ = key;
#line 221 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp4_ = value;
#line 221 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_key_file_set_value (_tmp1_, _tmp2_, _tmp3_, _tmp4_);
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			settings_manager_write_key_file (self, &_inner_error_);
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 552 "SettingsManager.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 220 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			e = _inner_error_;
#line 220 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_inner_error_ = NULL;
#line 224 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp5_ = group;
#line 224 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp6_ = key;
#line 224 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp7_ = value;
#line 224 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp8_ = e->message;
#line 224 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_error ("An error occured while setting the setting" " %s.%s to %s: %s", _tmp5_, _tmp6_, _tmp7_, _tmp8_);
#line 220 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_error_free0 (e);
#line 580 "SettingsManager.c"
		}
		__finally2:
#line 220 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 220 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 220 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_clear_error (&_inner_error_);
#line 220 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return;
#line 591 "SettingsManager.c"
		}
	}
}


/**
     * Function made for compability with older versions of GLib.
     */
static void settings_manager_write_key_file (SettingsManager* self, GError** error) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GKeyFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
#line 233 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = gofi_utils_get_config_file ();
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = _tmp0_;
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp3_ = self->priv->key_file;
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp4_ = g_key_file_to_data (_tmp3_, NULL, NULL);
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp5_ = _tmp4_;
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_file_set_contents (_tmp2_, _tmp5_, (gssize) -1, &_inner_error_);
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp5_);
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_propagate_error (error, _inner_error_);
#line 234 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return;
#line 634 "SettingsManager.c"
	}
}


/**
     * Generates the default configuration.
     * It also tries to automatically determine the location of the user's
     * Todo.txt directory by checking a set of common potential
     * "standard locations", which are defined in GOFI.TEST_DIRS in Utils.vala.
     */
static void settings_manager_generate_configuration (SettingsManager* self) {
	gchar* user_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* todo_dir = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp12_;
#line 243 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 244 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = g_get_home_dir ();
#line 244 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 244 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	user_dir = _tmp1_;
#line 248 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = user_dir;
#line 248 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp3_ = GOFI_TEST_DIRS[0];
#line 248 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp4_ = g_build_filename (_tmp2_, _tmp3_, NULL);
#line 248 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	todo_dir = _tmp4_;
#line 670 "SettingsManager.c"
	{
		const gchar** test_sub_dir_collection = NULL;
		gint test_sub_dir_collection_length1 = 0;
		gint _test_sub_dir_collection_size_ = 0;
		gint test_sub_dir_it = 0;
#line 251 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		test_sub_dir_collection = GOFI_TEST_DIRS;
#line 251 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		test_sub_dir_collection_length1 = G_N_ELEMENTS (GOFI_TEST_DIRS);
#line 251 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		for (test_sub_dir_it = 0; test_sub_dir_it < G_N_ELEMENTS (GOFI_TEST_DIRS); test_sub_dir_it = test_sub_dir_it + 1) {
#line 682 "SettingsManager.c"
			const gchar* test_sub_dir = NULL;
#line 251 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			test_sub_dir = test_sub_dir_collection[test_sub_dir_it];
#line 686 "SettingsManager.c"
			{
				gchar* test_dir = NULL;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				gboolean _tmp9_;
#line 252 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp5_ = user_dir;
#line 252 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp6_ = test_sub_dir;
#line 252 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp7_ = g_build_filename (_tmp5_, _tmp6_, NULL);
#line 252 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				test_dir = _tmp7_;
#line 253 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp8_ = test_dir;
#line 253 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp9_ = g_file_test (_tmp8_, G_FILE_TEST_EXISTS);
#line 253 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				if (_tmp9_) {
#line 708 "SettingsManager.c"
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 254 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp10_ = test_dir;
#line 254 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp11_ = g_strdup (_tmp10_);
#line 254 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_g_free0 (todo_dir);
#line 254 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					todo_dir = _tmp11_;
#line 255 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_g_free0 (test_dir);
#line 255 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					break;
#line 723 "SettingsManager.c"
				}
#line 251 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_g_free0 (test_dir);
#line 727 "SettingsManager.c"
			}
		}
	}
#line 259 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp12_ = todo_dir;
#line 259 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_todo_txt_location (self, _tmp12_);
#line 243 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (todo_dir);
#line 243 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (user_dir);
#line 739 "SettingsManager.c"
}


/**
     * Try to read the configuration from a keyfile from an older version.
     */
static gboolean settings_manager_import_from_old_path (SettingsManager* self) {
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GKeyFile* old_file = NULL;
	GKeyFile* _tmp5_;
	GError * _inner_error_ = NULL;
#line 265 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = gofi_utils_get_old_config_file ();
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = _tmp0_;
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp3_ = g_file_test (_tmp2_, G_FILE_TEST_EXISTS);
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp4_ = !_tmp3_;
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (_tmp4_) {
#line 267 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		result = FALSE;
#line 267 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return result;
#line 776 "SettingsManager.c"
	}
#line 271 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp5_ = g_key_file_new ();
#line 271 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	old_file = _tmp5_;
#line 782 "SettingsManager.c"
	{
		GKeyFile* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 274 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp6_ = old_file;
#line 274 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp7_ = gofi_utils_get_old_config_file ();
#line 274 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp8_ = _tmp7_;
#line 274 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp9_ = _tmp8_;
#line 274 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_key_file_load_from_file (_tmp6_, _tmp9_, G_KEY_FILE_KEEP_COMMENTS | G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error_);
#line 274 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_free0 (_tmp9_);
#line 274 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 802 "SettingsManager.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		FILE* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 273 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		e = _inner_error_;
#line 273 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_inner_error_ = NULL;
#line 277 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp10_ = stderr;
#line 277 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp11_ = gofi_utils_get_old_config_file ();
#line 277 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp12_ = _tmp11_;
#line 277 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp13_ = _tmp12_;
#line 277 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		fprintf (_tmp10_, "Reading %s failed", _tmp13_);
#line 277 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_free0 (_tmp13_);
#line 278 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp14_ = e;
#line 278 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp15_ = _tmp14_->message;
#line 278 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_warning ("SettingsManager.vala:278: %s", _tmp15_);
#line 279 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		result = FALSE;
#line 279 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_error_free0 (e);
#line 279 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_key_file_unref0 (old_file);
#line 279 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return result;
#line 846 "SettingsManager.c"
	}
	__finally3:
#line 273 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 851 "SettingsManager.c"
		gboolean _tmp16_ = FALSE;
#line 273 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_key_file_unref0 (old_file);
#line 273 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 273 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_clear_error (&_inner_error_);
#line 273 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return _tmp16_;
#line 861 "SettingsManager.c"
	}
	{
		GKeyFile* _tmp17_;
		gchar* _tmp18_;
		gchar** _tmp19_;
		gchar** _tmp20_;
		gint _tmp20__length1;
		GKeyFile* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar** _tmp26_;
		gchar** _tmp27_;
		gint _tmp27__length1;
		GKeyFile* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar** _tmp35_;
		gchar** _tmp36_;
		gint _tmp36__length1;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp17_ = old_file;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp18_ = g_strdup ("location");
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp19_ = g_new0 (gchar*, 1 + 1);
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp19_[0] = _tmp18_;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp20_ = _tmp19_;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp20__length1 = 1;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		settings_manager_import_group (self, _tmp17_, SETTINGS_MANAGER_GROUP_TODO_TXT, _tmp20_, 1, &_inner_error_);
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 903 "SettingsManager.c"
			gboolean _tmp21_ = FALSE;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 907 "SettingsManager.c"
				goto __catch4_g_key_file_error;
			}
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_key_file_unref0 (old_file);
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_clear_error (&_inner_error_);
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return _tmp21_;
#line 918 "SettingsManager.c"
		}
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp22_ = old_file;
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp23_ = g_strdup ("task_duration");
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp24_ = g_strdup ("break_duration");
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp25_ = g_strdup ("reminder_time");
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp26_ = g_new0 (gchar*, 3 + 1);
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp26_[0] = _tmp23_;
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp26_[1] = _tmp24_;
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp26_[2] = _tmp25_;
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp27_ = _tmp26_;
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp27__length1 = 3;
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		settings_manager_import_group (self, _tmp22_, SETTINGS_MANAGER_GROUP_TIMER, _tmp27_, 3, &_inner_error_);
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 946 "SettingsManager.c"
			gboolean _tmp28_ = FALSE;
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 950 "SettingsManager.c"
				goto __catch4_g_key_file_error;
			}
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_key_file_unref0 (old_file);
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_clear_error (&_inner_error_);
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return _tmp28_;
#line 961 "SettingsManager.c"
		}
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp29_ = old_file;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp30_ = g_strdup ("win_x");
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp31_ = g_strdup ("win_y");
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp32_ = g_strdup ("win_width");
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp33_ = g_strdup ("win_height");
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp34_ = g_strdup ("use_dark_theme");
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp35_ = g_new0 (gchar*, 5 + 1);
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp35_[0] = _tmp30_;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp35_[1] = _tmp31_;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp35_[2] = _tmp32_;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp35_[3] = _tmp33_;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp35_[4] = _tmp34_;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp36_ = _tmp35_;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp36__length1 = 5;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		settings_manager_import_group (self, _tmp29_, SETTINGS_MANAGER_GROUP_UI, _tmp36_, 5, &_inner_error_);
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp36_ = (_vala_array_free (_tmp36_, _tmp36__length1, (GDestroyNotify) g_free), NULL);
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 997 "SettingsManager.c"
			gboolean _tmp37_ = FALSE;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1001 "SettingsManager.c"
				goto __catch4_g_key_file_error;
			}
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_g_key_file_unref0 (old_file);
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			g_clear_error (&_inner_error_);
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return _tmp37_;
#line 1012 "SettingsManager.c"
		}
	}
	goto __finally4;
	__catch4_g_key_file_error:
	{
		GError* e = NULL;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		e = _inner_error_;
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_inner_error_ = NULL;
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp38_ = gofi_utils_get_old_config_file ();
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp39_ = _tmp38_;
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp40_ = _tmp39_;
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp41_ = e;
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_tmp42_ = _tmp41_->message;
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_warning (_ ("Couldn't properly import settings from %s: %s"), _tmp40_, _tmp42_);
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_free0 (_tmp40_);
#line 300 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		result = FALSE;
#line 300 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_error_free0 (e);
#line 300 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_key_file_unref0 (old_file);
#line 300 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return result;
#line 1050 "SettingsManager.c"
	}
	__finally4:
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1055 "SettingsManager.c"
		gboolean _tmp43_ = FALSE;
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		_g_key_file_unref0 (old_file);
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_clear_error (&_inner_error_);
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return _tmp43_;
#line 1065 "SettingsManager.c"
	}
#line 302 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = TRUE;
#line 302 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_key_file_unref0 (old_file);
#line 302 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1073 "SettingsManager.c"
}


static void settings_manager_import_group (SettingsManager* self, GKeyFile* old_file, const gchar* group, gchar** keys, int keys_length1, GError** error) {
	GKeyFile* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GError * _inner_error_ = NULL;
#line 305 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 305 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (old_file != NULL);
#line 305 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (group != NULL);
#line 306 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = old_file;
#line 306 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = group;
#line 306 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = g_key_file_has_group (_tmp0_, _tmp1_);
#line 306 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (!_tmp2_) {
#line 307 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return;
#line 1100 "SettingsManager.c"
	}
#line 309 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp3_ = keys;
#line 309 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp3__length1 = keys_length1;
#line 1106 "SettingsManager.c"
	{
		gchar** key_collection = NULL;
		gint key_collection_length1 = 0;
		gint _key_collection_size_ = 0;
		gint key_it = 0;
#line 309 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		key_collection = _tmp3_;
#line 309 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		key_collection_length1 = _tmp3__length1;
#line 309 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		for (key_it = 0; key_it < _tmp3__length1; key_it = key_it + 1) {
#line 1118 "SettingsManager.c"
			gchar* _tmp4_;
			gchar* key = NULL;
#line 309 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			_tmp4_ = g_strdup (key_collection[key_it]);
#line 309 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			key = _tmp4_;
#line 1125 "SettingsManager.c"
			{
				gboolean _tmp5_ = FALSE;
				GKeyFile* _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				gboolean _tmp9_;
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp6_ = old_file;
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp7_ = group;
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp8_ = key;
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp9_ = g_key_file_has_key (_tmp6_, _tmp7_, _tmp8_, &_inner_error_);
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_tmp5_ = _tmp9_;
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
						g_propagate_error (error, _inner_error_);
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
						_g_free0 (key);
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
						return;
#line 1152 "SettingsManager.c"
					} else {
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
						_g_free0 (key);
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
						g_clear_error (&_inner_error_);
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
						return;
#line 1162 "SettingsManager.c"
					}
				}
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				if (_tmp5_) {
#line 1167 "SettingsManager.c"
					gchar* _tmp10_ = NULL;
					GKeyFile* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					GKeyFile* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp11_ = old_file;
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp12_ = group;
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp13_ = key;
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp14_ = g_key_file_get_value (_tmp11_, _tmp12_, _tmp13_, &_inner_error_);
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp10_ = _tmp14_;
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
						if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
							g_propagate_error (error, _inner_error_);
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
							_g_free0 (key);
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
							return;
#line 1196 "SettingsManager.c"
						} else {
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
							_g_free0 (key);
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
							g_clear_error (&_inner_error_);
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
							return;
#line 1206 "SettingsManager.c"
						}
					}
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp15_ = self->priv->key_file;
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp16_ = group;
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_tmp17_ = key;
#line 311 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					g_key_file_set_value (_tmp15_, _tmp16_, _tmp17_, _tmp10_);
#line 310 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
					_g_free0 (_tmp10_);
#line 1219 "SettingsManager.c"
				}
#line 309 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
				_g_free0 (key);
#line 1223 "SettingsManager.c"
			}
		}
	}
}


SettingsManager* settings_manager_construct (GType object_type) {
	SettingsManager* self = NULL;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	self = (SettingsManager*) g_type_create_instance (object_type);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return self;
#line 1236 "SettingsManager.c"
}


SettingsManager* settings_manager_new (void) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return settings_manager_construct (TYPE_SETTINGS_MANAGER);
#line 1243 "SettingsManager.c"
}


gchar* settings_manager_get_todo_txt_location (SettingsManager* self) {
	gchar* result;
	gchar* _tmp0_;
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_TODO_TXT, "location", "");
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp0_;
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1258 "SettingsManager.c"
}


void settings_manager_set_todo_txt_location (SettingsManager* self, const gchar* value) {
	const gchar* _tmp0_;
#line 44 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_TODO_TXT, "location", _tmp0_);
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_signal_emit (self, settings_manager_signals[SETTINGS_MANAGER_TODO_TXT_LOCATION_CHANGED_SIGNAL], 0);
#line 1272 "SettingsManager.c"
}


gint settings_manager_get_task_duration (SettingsManager* self) {
	gint result;
	gchar* duration = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
#line 51 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_TIMER, "task_duration", "1500");
#line 52 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	duration = _tmp0_;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = atoi (duration);
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (duration);
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1295 "SettingsManager.c"
}


void settings_manager_set_task_duration (SettingsManager* self, gint value) {
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 55 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_TIMER, "task_duration", _tmp2_);
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_signal_emit (self, settings_manager_signals[SETTINGS_MANAGER_TIMER_DURATION_CHANGED_SIGNAL], 0);
#line 1317 "SettingsManager.c"
}


gint settings_manager_get_break_duration (SettingsManager* self) {
	gint result;
	gchar* duration = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
#line 61 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_TIMER, "break_duration", "300");
#line 62 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	duration = _tmp0_;
#line 63 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = atoi (duration);
#line 63 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_;
#line 63 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (duration);
#line 63 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1340 "SettingsManager.c"
}


void settings_manager_set_break_duration (SettingsManager* self, gint value) {
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 66 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 66 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 66 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 66 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_TIMER, "break_duration", _tmp2_);
#line 66 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_signal_emit (self, settings_manager_signals[SETTINGS_MANAGER_TIMER_DURATION_CHANGED_SIGNAL], 0);
#line 1362 "SettingsManager.c"
}


gint settings_manager_get_reminder_time (SettingsManager* self) {
	gint result;
	gchar* time = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
#line 71 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_TIMER, "reminder_time", "60");
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	time = _tmp0_;
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = atoi (time);
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_;
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (time);
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1385 "SettingsManager.c"
}


void settings_manager_set_reminder_time (SettingsManager* self, gint value) {
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 75 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_TIMER, "reminder_time", _tmp2_);
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 1405 "SettingsManager.c"
}


gboolean settings_manager_get_reminder_active (SettingsManager* self) {
	gboolean result;
	gint _tmp0_;
	gint _tmp1_;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_reminder_time (self);
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = _tmp0_;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_ > 0;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1423 "SettingsManager.c"
}


gint settings_manager_get_win_x (SettingsManager* self) {
	gint result;
	gchar* x = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
#line 86 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_UI, "win_x", "-1");
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	x = _tmp0_;
#line 88 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = atoi (x);
#line 88 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_;
#line 88 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (x);
#line 88 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1446 "SettingsManager.c"
}


void settings_manager_set_win_x (SettingsManager* self, gint value) {
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 90 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_UI, "win_x", _tmp2_);
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 1466 "SettingsManager.c"
}


gint settings_manager_get_win_y (SettingsManager* self) {
	gint result;
	gchar* y = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
#line 95 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_UI, "win_y", "-1");
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	y = _tmp0_;
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = atoi (y);
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_;
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (y);
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1489 "SettingsManager.c"
}


void settings_manager_set_win_y (SettingsManager* self, gint value) {
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 99 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_UI, "win_y", _tmp2_);
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 1509 "SettingsManager.c"
}


gint settings_manager_get_win_width (SettingsManager* self) {
	gint result;
	gchar* width = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
#line 104 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_UI, "win_width", "350");
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	width = _tmp0_;
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = atoi (width);
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_;
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (width);
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1532 "SettingsManager.c"
}


void settings_manager_set_win_width (SettingsManager* self, gint value) {
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 108 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_UI, "win_width", _tmp2_);
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 1552 "SettingsManager.c"
}


gint settings_manager_get_win_height (SettingsManager* self) {
	gint result;
	gchar* height = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
#line 113 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 114 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_UI, "win_height", "650");
#line 114 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	height = _tmp0_;
#line 115 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = atoi (height);
#line 115 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_;
#line 115 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (height);
#line 115 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1575 "SettingsManager.c"
}


void settings_manager_set_win_height (SettingsManager* self, gint value) {
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 117 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 118 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 118 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
#line 118 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 118 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_UI, "win_height", _tmp2_);
#line 118 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 1595 "SettingsManager.c"
}


static gboolean bool_parse (const gchar* str) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
#line 44 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 45 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (g_strcmp0 (_tmp0_, "true") == 0) {
#line 46 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = TRUE;
#line 46 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 1612 "SettingsManager.c"
	} else {
#line 48 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = FALSE;
#line 48 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 1618 "SettingsManager.c"
	}
}


gboolean settings_manager_get_use_header_bar (SettingsManager* self) {
	gboolean result;
	gchar* use_header_bar = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 122 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_header_bar_default (self);
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = _tmp0_;
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_UI, "use_header_bar", _tmp1_);
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp3_ = _tmp2_;
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp1_);
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	use_header_bar = _tmp3_;
#line 126 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp4_ = bool_parse (use_header_bar);
#line 126 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp4_;
#line 126 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (use_header_bar);
#line 126 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1653 "SettingsManager.c"
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
#line 37 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	if (self) {
#line 1661 "SettingsManager.c"
		gchar* _tmp0_;
#line 38 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp0_;
#line 38 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 1669 "SettingsManager.c"
	} else {
		gchar* _tmp1_;
#line 40 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		result = _tmp1_;
#line 40 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
		return result;
#line 1678 "SettingsManager.c"
	}
}


void settings_manager_set_use_header_bar (SettingsManager* self, gboolean value) {
	gboolean _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 128 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 129 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 129 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = bool_to_string (_tmp0_);
#line 129 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 129 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_UI, "use_header_bar", _tmp2_);
#line 129 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 130 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_signal_emit (self, settings_manager_signals[SETTINGS_MANAGER_USE_HEADER_BAR_CHANGED_SIGNAL], 0);
#line 1701 "SettingsManager.c"
}


gboolean settings_manager_get_use_dark_theme (SettingsManager* self) {
	gboolean result;
	gchar* use_dark = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_;
#line 134 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 135 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = settings_manager_get_value (self, SETTINGS_MANAGER_GROUP_UI, "use_dark_theme", "false");
#line 135 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	use_dark = _tmp0_;
#line 138 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = bool_parse (use_dark);
#line 138 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	result = _tmp1_;
#line 138 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (use_dark);
#line 138 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return result;
#line 1724 "SettingsManager.c"
}


void settings_manager_set_use_dark_theme (SettingsManager* self, gboolean value) {
	gboolean _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 140 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (self != NULL);
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp0_ = value;
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp1_ = bool_to_string (_tmp0_);
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp2_ = _tmp1_;
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_set_value (self, SETTINGS_MANAGER_GROUP_UI, "use_dark_theme", _tmp2_);
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_free0 (_tmp2_);
#line 142 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_tmp3_ = value;
#line 142 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_signal_emit (self, settings_manager_signals[SETTINGS_MANAGER_USE_DARK_THEME_CHANGED_SIGNAL], 0, _tmp3_);
#line 1749 "SettingsManager.c"
}


static void value_settings_manager_init (GValue* value) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	value->data[0].v_pointer = NULL;
#line 1756 "SettingsManager.c"
}


static void value_settings_manager_free_value (GValue* value) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (value->data[0].v_pointer) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		settings_manager_unref (value->data[0].v_pointer);
#line 1765 "SettingsManager.c"
	}
}


static void value_settings_manager_copy_value (const GValue* src_value, GValue* dest_value) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (src_value->data[0].v_pointer) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		dest_value->data[0].v_pointer = settings_manager_ref (src_value->data[0].v_pointer);
#line 1775 "SettingsManager.c"
	} else {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1779 "SettingsManager.c"
	}
}


static gpointer value_settings_manager_peek_pointer (const GValue* value) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return value->data[0].v_pointer;
#line 1787 "SettingsManager.c"
}


static gchar* value_settings_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (collect_values[0].v_pointer) {
#line 1794 "SettingsManager.c"
		SettingsManager * object;
		object = collect_values[0].v_pointer;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1801 "SettingsManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1805 "SettingsManager.c"
		}
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		value->data[0].v_pointer = settings_manager_ref (object);
#line 1809 "SettingsManager.c"
	} else {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		value->data[0].v_pointer = NULL;
#line 1813 "SettingsManager.c"
	}
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return NULL;
#line 1817 "SettingsManager.c"
}


static gchar* value_settings_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SettingsManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (!object_p) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1828 "SettingsManager.c"
	}
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (!value->data[0].v_pointer) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		*object_p = NULL;
#line 1834 "SettingsManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		*object_p = value->data[0].v_pointer;
#line 1838 "SettingsManager.c"
	} else {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		*object_p = settings_manager_ref (value->data[0].v_pointer);
#line 1842 "SettingsManager.c"
	}
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return NULL;
#line 1846 "SettingsManager.c"
}


GParamSpec* param_spec_settings_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSettingsManager* spec;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SETTINGS_MANAGER), NULL);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return G_PARAM_SPEC (spec);
#line 1860 "SettingsManager.c"
}


gpointer value_get_settings_manager (const GValue* value) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SETTINGS_MANAGER), NULL);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return value->data[0].v_pointer;
#line 1869 "SettingsManager.c"
}


void value_set_settings_manager (GValue* value, gpointer v_object) {
	SettingsManager * old;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SETTINGS_MANAGER));
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	old = value->data[0].v_pointer;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (v_object) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SETTINGS_MANAGER));
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		value->data[0].v_pointer = v_object;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		settings_manager_ref (value->data[0].v_pointer);
#line 1889 "SettingsManager.c"
	} else {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		value->data[0].v_pointer = NULL;
#line 1893 "SettingsManager.c"
	}
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (old) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		settings_manager_unref (old);
#line 1899 "SettingsManager.c"
	}
}


void value_take_settings_manager (GValue* value, gpointer v_object) {
	SettingsManager * old;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SETTINGS_MANAGER));
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	old = value->data[0].v_pointer;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (v_object) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SETTINGS_MANAGER));
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		value->data[0].v_pointer = v_object;
#line 1918 "SettingsManager.c"
	} else {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		value->data[0].v_pointer = NULL;
#line 1922 "SettingsManager.c"
	}
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (old) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		settings_manager_unref (old);
#line 1928 "SettingsManager.c"
	}
}


static void settings_manager_class_init (SettingsManagerClass * klass) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_parent_class = g_type_class_peek_parent (klass);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	((SettingsManagerClass *) klass)->finalize = settings_manager_finalize;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_type_class_add_private (klass, sizeof (SettingsManagerPrivate));
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_signals[SETTINGS_MANAGER_TODO_TXT_LOCATION_CHANGED_SIGNAL] = g_signal_new ("todo-txt-location-changed", TYPE_SETTINGS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_signals[SETTINGS_MANAGER_TIMER_DURATION_CHANGED_SIGNAL] = g_signal_new ("timer-duration-changed", TYPE_SETTINGS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_signals[SETTINGS_MANAGER_USE_DARK_THEME_CHANGED_SIGNAL] = g_signal_new ("use-dark-theme-changed", TYPE_SETTINGS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	settings_manager_signals[SETTINGS_MANAGER_USE_HEADER_BAR_CHANGED_SIGNAL] = g_signal_new ("use-header-bar-changed", TYPE_SETTINGS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1948 "SettingsManager.c"
}


static void settings_manager_instance_init (SettingsManager * self) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	self->priv = SETTINGS_MANAGER_GET_PRIVATE (self);
#line 34 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	self->first_start = FALSE;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	self->ref_count = 1;
#line 1959 "SettingsManager.c"
}


static void settings_manager_finalize (SettingsManager * obj) {
	SettingsManager * self;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SETTINGS_MANAGER, SettingsManager);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_signal_handlers_destroy (self);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	_g_key_file_unref0 (self->priv->key_file);
#line 1971 "SettingsManager.c"
}


/**
 * A class that handles access to settings in a transparent manner.
 * Its main motivation is the option of easily replacing Glib.KeyFile with
 * another settings storage mechanism in the future.
 */
GType settings_manager_get_type (void) {
	static volatile gsize settings_manager_type_id__volatile = 0;
	if (g_once_init_enter (&settings_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_settings_manager_init, value_settings_manager_free_value, value_settings_manager_copy_value, value_settings_manager_peek_pointer, "p", value_settings_manager_collect_value, "p", value_settings_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SettingsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SettingsManager), 0, (GInstanceInitFunc) settings_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType settings_manager_type_id;
		settings_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SettingsManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&settings_manager_type_id__volatile, settings_manager_type_id);
	}
	return settings_manager_type_id__volatile;
}


gpointer settings_manager_ref (gpointer instance) {
	SettingsManager * self;
	self = instance;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	return instance;
#line 2001 "SettingsManager.c"
}


void settings_manager_unref (gpointer instance) {
	SettingsManager * self;
	self = instance;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		SETTINGS_MANAGER_GET_CLASS (self)->finalize (self);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SettingsManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2014 "SettingsManager.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



