/* TaskStore.c generated by valac 0.38.8, the Vala compiler
 * generated from TaskStore.vala, do not modify */

/* Copyright 2014-2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include <glib.h>
#include <glib-object.h>


#define TYPE_DRAG_LIST_MODEL (drag_list_model_get_type ())
#define DRAG_LIST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAG_LIST_MODEL, DragListModel))
#define IS_DRAG_LIST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAG_LIST_MODEL))
#define DRAG_LIST_MODEL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DRAG_LIST_MODEL, DragListModelIface))

typedef struct _DragListModel DragListModel;
typedef struct _DragListModelIface DragListModelIface;

#define TYPE_TASK_STORE (task_store_get_type ())
#define TASK_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TASK_STORE, TaskStore))
#define TASK_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TASK_STORE, TaskStoreClass))
#define IS_TASK_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TASK_STORE))
#define IS_TASK_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TASK_STORE))
#define TASK_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TASK_STORE, TaskStoreClass))

typedef struct _TaskStore TaskStore;
typedef struct _TaskStoreClass TaskStoreClass;
typedef struct _TaskStorePrivate TaskStorePrivate;

#define TYPE_SEQUENTIAL_LIST (sequential_list_get_type ())
#define SEQUENTIAL_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEQUENTIAL_LIST, SequentialList))
#define SEQUENTIAL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEQUENTIAL_LIST, SequentialListClass))
#define IS_SEQUENTIAL_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEQUENTIAL_LIST))
#define IS_SEQUENTIAL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEQUENTIAL_LIST))
#define SEQUENTIAL_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEQUENTIAL_LIST, SequentialListClass))

typedef struct _SequentialList SequentialList;
typedef struct _SequentialListClass SequentialListClass;
enum  {
	TASK_STORE_0_PROPERTY,
	TASK_STORE_DONE_BY_DEFAULT_PROPERTY,
	TASK_STORE_NUM_PROPERTIES
};
static GParamSpec* task_store_properties[TASK_STORE_NUM_PROPERTIES];
#define _sequential_list_unref0(var) ((var == NULL) ? NULL : (var = (sequential_list_unref (var), NULL)))

#define TYPE_TODO_TASK (todo_task_get_type ())
#define TODO_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TODO_TASK, TodoTask))
#define TODO_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TODO_TASK, TodoTaskClass))
#define IS_TODO_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TODO_TASK))
#define IS_TODO_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TODO_TASK))
#define TODO_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TODO_TASK, TodoTaskClass))

typedef struct _TodoTask TodoTask;
typedef struct _TodoTaskClass TodoTaskClass;
enum  {
	TASK_STORE_TASK_DATA_CHANGED_SIGNAL,
	TASK_STORE_TASK_DONE_CHANGED_SIGNAL,
	TASK_STORE_TASK_BECAME_INVALID_SIGNAL,
	TASK_STORE_NUM_SIGNALS
};
static guint task_store_signals[TASK_STORE_NUM_SIGNALS] = {0};

struct _DragListModelIface {
	GTypeInterface parent_iface;
	void (*move_item) (DragListModel* self, guint old_position, guint new_position);
	GObject* (*get_item) (DragListModel* self, guint position);
	GType (*get_item_type) (DragListModel* self);
	guint (*get_n_items) (DragListModel* self);
};

struct _TaskStore {
	GObject parent_instance;
	TaskStorePrivate * priv;
};

struct _TaskStoreClass {
	GObjectClass parent_class;
};

struct _TaskStorePrivate {
	SequentialList* tasks;
	gboolean _done_by_default;
};


static gpointer task_store_parent_class = NULL;
static DragListModelIface * task_store_drag_list_model_parent_iface = NULL;

GType drag_list_model_get_type (void) G_GNUC_CONST;
GType task_store_get_type (void) G_GNUC_CONST;
gpointer sequential_list_ref (gpointer instance);
void sequential_list_unref (gpointer instance);
GParamSpec* param_spec_sequential_list (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_sequential_list (GValue* value, gpointer v_object);
void value_take_sequential_list (GValue* value, gpointer v_object);
gpointer value_get_sequential_list (const GValue* value);
GType sequential_list_get_type (void) G_GNUC_CONST;
#define TASK_STORE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TASK_STORE, TaskStorePrivate))
TaskStore* task_store_new (gboolean done_by_default);
TaskStore* task_store_construct (GType object_type, gboolean done_by_default);
static void task_store_set_done_by_default (TaskStore* self, gboolean value);
GType todo_task_get_type (void) G_GNUC_CONST;
SequentialList* sequential_list_new (GType item_type);
SequentialList* sequential_list_construct (GType object_type, GType item_type);
void task_store_add_task (TaskStore* self, TodoTask* task);
void sequential_list_append_item (SequentialList* self, GObject* item);
static void task_store_on_task_done (TaskStore* self, TodoTask* task);
static void _task_store_on_task_done_todo_task_done_changed (TodoTask* _sender, gpointer self);
static void task_store_on_task_data_changed (TaskStore* self, TodoTask* task);
static void _task_store_on_task_data_changed_todo_task_data_changed (TodoTask* _sender, gpointer self);
guint sequential_list_get_length (SequentialList* self);
void task_store_clear (TaskStore* self);
void sequential_list_clear (SequentialList* self);
void task_store_remove_task (TaskStore* self, TodoTask* task);
guint sequential_list_remove_item (SequentialList* self, GObject* item);
static GType task_store_real_get_item_type (DragListModel* base);
GType sequential_list_get_item_type (SequentialList* self);
static GObject* task_store_real_get_item (DragListModel* base, guint position);
GObject* sequential_list_get_item (SequentialList* self, guint position);
static guint task_store_real_get_n_items (DragListModel* base);
static void task_store_real_move_item (DragListModel* base, guint old_position, guint new_position);
void sequential_list_move_item (SequentialList* self, guint old_position, guint new_position);
gboolean todo_task_get_valid (TodoTask* self);
gboolean task_store_get_done_by_default (TaskStore* self);
static void task_store_finalize (GObject * obj);
static void _vala_task_store_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_task_store_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
     * Constructor of the TaskStore class
     */
TaskStore* task_store_construct (GType object_type, gboolean done_by_default) {
	TaskStore * self = NULL;
	gboolean _tmp0_;
	SequentialList* _tmp1_;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	self = (TaskStore*) g_object_new (object_type, NULL);
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = done_by_default;
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	task_store_set_done_by_default (self, _tmp0_);
#line 37 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp1_ = sequential_list_new (TYPE_TODO_TASK);
#line 37 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_sequential_list_unref0 (self->priv->tasks);
#line 37 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	self->priv->tasks = _tmp1_;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	return self;
#line 167 "TaskStore.c"
}


TaskStore* task_store_new (gboolean done_by_default) {
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	return task_store_construct (TYPE_TASK_STORE, done_by_default);
#line 174 "TaskStore.c"
}


static void _task_store_on_task_done_todo_task_done_changed (TodoTask* _sender, gpointer self) {
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	task_store_on_task_done ((TaskStore*) self, _sender);
#line 181 "TaskStore.c"
}


static void _task_store_on_task_data_changed_todo_task_data_changed (TodoTask* _sender, gpointer self) {
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	task_store_on_task_data_changed ((TaskStore*) self, _sender);
#line 188 "TaskStore.c"
}


void task_store_add_task (TaskStore* self, TodoTask* task) {
	SequentialList* _tmp0_;
	TodoTask* _tmp1_;
	TodoTask* _tmp2_;
	TodoTask* _tmp3_;
	SequentialList* _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (self != NULL);
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (task != NULL);
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = self->priv->tasks;
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp1_ = task;
#line 41 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	sequential_list_append_item (_tmp0_, (GObject*) _tmp1_);
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp2_ = task;
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_connect_object (_tmp2_, "done-changed", (GCallback) _task_store_on_task_done_todo_task_done_changed, self, 0);
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp3_ = task;
#line 43 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_connect_object (_tmp3_, "data-changed", (GCallback) _task_store_on_task_data_changed_todo_task_data_changed, self, 0);
#line 44 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp4_ = self->priv->tasks;
#line 44 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp5_ = sequential_list_get_length (_tmp4_);
#line 44 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp6_ = _tmp5_;
#line 44 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_emit_by_name ((DragListModel*) self, "items-changed", _tmp6_ - 1, (guint) 0, (guint) 1);
#line 226 "TaskStore.c"
}


void task_store_clear (TaskStore* self) {
	guint length = 0U;
	SequentialList* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	SequentialList* _tmp3_;
#line 47 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (self != NULL);
#line 48 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = self->priv->tasks;
#line 48 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp1_ = sequential_list_get_length (_tmp0_);
#line 48 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp2_ = _tmp1_;
#line 48 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	length = _tmp2_;
#line 49 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp3_ = self->priv->tasks;
#line 49 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	sequential_list_clear (_tmp3_);
#line 50 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_emit_by_name ((DragListModel*) self, "items-changed", (guint) 0, length, (guint) 0);
#line 252 "TaskStore.c"
}


void task_store_remove_task (TaskStore* self, TodoTask* task) {
	TodoTask* _tmp0_;
	guint _tmp1_;
	TodoTask* _tmp2_;
	guint _tmp3_;
	SequentialList* _tmp4_;
	TodoTask* _tmp5_;
	guint _tmp6_;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (self != NULL);
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (task != NULL);
#line 54 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = task;
#line 54 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_parse_name ("done-changed", TYPE_TODO_TASK, &_tmp1_, NULL, FALSE);
#line 54 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _task_store_on_task_done_todo_task_done_changed, self);
#line 55 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp2_ = task;
#line 55 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_parse_name ("data-changed", TYPE_TODO_TASK, &_tmp3_, NULL, FALSE);
#line 55 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _task_store_on_task_data_changed_todo_task_data_changed, self);
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp4_ = self->priv->tasks;
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp5_ = task;
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp6_ = sequential_list_remove_item (_tmp4_, (GObject*) _tmp5_);
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_emit_by_name ((DragListModel*) self, "items-changed", _tmp6_, (guint) 1, (guint) 0);
#line 288 "TaskStore.c"
}


static GType task_store_real_get_item_type (DragListModel* base) {
	TaskStore * self;
	GType result = 0UL;
	SequentialList* _tmp0_;
	GType _tmp1_;
#line 59 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	self = (TaskStore*) base;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = self->priv->tasks;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp1_ = sequential_list_get_item_type (_tmp0_);
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	result = _tmp1_;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	return result;
#line 307 "TaskStore.c"
}


static GObject* task_store_real_get_item (DragListModel* base, guint position) {
	TaskStore * self;
	GObject* result = NULL;
	SequentialList* _tmp0_;
	guint _tmp1_;
	GObject* _tmp2_;
#line 63 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	self = (TaskStore*) base;
#line 64 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = self->priv->tasks;
#line 64 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp1_ = position;
#line 64 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp2_ = sequential_list_get_item (_tmp0_, _tmp1_);
#line 64 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	result = _tmp2_;
#line 64 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	return result;
#line 329 "TaskStore.c"
}


static guint task_store_real_get_n_items (DragListModel* base) {
	TaskStore * self;
	guint result = 0U;
	SequentialList* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	self = (TaskStore*) base;
#line 68 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = self->priv->tasks;
#line 68 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp1_ = sequential_list_get_length (_tmp0_);
#line 68 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp2_ = _tmp1_;
#line 68 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	result = _tmp2_;
#line 68 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	return result;
#line 351 "TaskStore.c"
}


static void task_store_real_move_item (DragListModel* base, guint old_position, guint new_position) {
	TaskStore * self;
	guint _tmp0_;
	guint _tmp1_;
	SequentialList* _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
#line 71 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	self = (TaskStore*) base;
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = old_position;
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp1_ = new_position;
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	if (_tmp0_ == _tmp1_) {
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		return;
#line 372 "TaskStore.c"
	}
#line 75 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp2_ = self->priv->tasks;
#line 75 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp3_ = old_position;
#line 75 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp4_ = new_position;
#line 75 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	sequential_list_move_item (_tmp2_, _tmp3_, _tmp4_);
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_emit (self, task_store_signals[TASK_STORE_TASK_DATA_CHANGED_SIGNAL], 0);
#line 384 "TaskStore.c"
}


static void task_store_on_task_done (TaskStore* self, TodoTask* task) {
	TodoTask* _tmp0_;
#line 79 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (self != NULL);
#line 79 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (task != NULL);
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = task;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_signal_emit (self, task_store_signals[TASK_STORE_TASK_DONE_CHANGED_SIGNAL], 0, _tmp0_);
#line 398 "TaskStore.c"
}


static void task_store_on_task_data_changed (TaskStore* self, TodoTask* task) {
	TodoTask* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (self != NULL);
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (task != NULL);
#line 84 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = task;
#line 84 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp1_ = todo_task_get_valid (_tmp0_);
#line 84 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp2_ = _tmp1_;
#line 84 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	if (_tmp2_) {
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		g_signal_emit (self, task_store_signals[TASK_STORE_TASK_DATA_CHANGED_SIGNAL], 0);
#line 420 "TaskStore.c"
	} else {
		TodoTask* _tmp3_;
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		_tmp3_ = task;
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		g_signal_emit (self, task_store_signals[TASK_STORE_TASK_BECAME_INVALID_SIGNAL], 0, _tmp3_);
#line 427 "TaskStore.c"
	}
}


gboolean task_store_get_done_by_default (TaskStore* self) {
	gboolean result;
	gboolean _tmp0_;
#line 22 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_tmp0_ = self->priv->_done_by_default;
#line 22 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	result = _tmp0_;
#line 22 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	return result;
#line 443 "TaskStore.c"
}


static void task_store_set_done_by_default (TaskStore* self, gboolean value) {
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_return_if_fail (self != NULL);
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	if (task_store_get_done_by_default (self) != value) {
#line 452 "TaskStore.c"
		gboolean _tmp0_;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		_tmp0_ = value;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		self->priv->_done_by_default = _tmp0_;
#line 23 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		g_object_notify_by_pspec ((GObject *) self, task_store_properties[TASK_STORE_DONE_BY_DEFAULT_PROPERTY]);
#line 460 "TaskStore.c"
	}
}


static void task_store_class_init (TaskStoreClass * klass) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	task_store_parent_class = g_type_class_peek_parent (klass);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_type_class_add_private (klass, sizeof (TaskStorePrivate));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_task_store_get_property;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_task_store_set_property;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	G_OBJECT_CLASS (klass)->finalize = task_store_finalize;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TASK_STORE_DONE_BY_DEFAULT_PROPERTY, task_store_properties[TASK_STORE_DONE_BY_DEFAULT_PROPERTY] = g_param_spec_boolean ("done-by-default", "done-by-default", "done-by-default", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	task_store_signals[TASK_STORE_TASK_DATA_CHANGED_SIGNAL] = g_signal_new ("task-data-changed", TYPE_TASK_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	task_store_signals[TASK_STORE_TASK_DONE_CHANGED_SIGNAL] = g_signal_new ("task-done-changed", TYPE_TASK_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TODO_TASK);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	task_store_signals[TASK_STORE_TASK_BECAME_INVALID_SIGNAL] = g_signal_new ("task-became-invalid", TYPE_TASK_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TODO_TASK);
#line 484 "TaskStore.c"
}


static void task_store_drag_list_model_interface_init (DragListModelIface * iface) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	task_store_drag_list_model_parent_iface = g_type_interface_peek_parent (iface);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	iface->get_item_type = (GType (*) (DragListModel *)) task_store_real_get_item_type;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	iface->get_item = (GObject* (*) (DragListModel *, guint)) task_store_real_get_item;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	iface->get_n_items = (guint (*) (DragListModel *)) task_store_real_get_n_items;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	iface->move_item = (void (*) (DragListModel *, guint, guint)) task_store_real_move_item;
#line 499 "TaskStore.c"
}


static void task_store_instance_init (TaskStore * self) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	self->priv = TASK_STORE_GET_PRIVATE (self);
#line 506 "TaskStore.c"
}


static void task_store_finalize (GObject * obj) {
	TaskStore * self;
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TASK_STORE, TaskStore);
#line 19 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	_sequential_list_unref0 (self->priv->tasks);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	G_OBJECT_CLASS (task_store_parent_class)->finalize (obj);
#line 518 "TaskStore.c"
}


GType task_store_get_type (void) {
	static volatile gsize task_store_type_id__volatile = 0;
	if (g_once_init_enter (&task_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TaskStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) task_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TaskStore), 0, (GInstanceInitFunc) task_store_instance_init, NULL };
		static const GInterfaceInfo drag_list_model_info = { (GInterfaceInitFunc) task_store_drag_list_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType task_store_type_id;
		task_store_type_id = g_type_register_static (G_TYPE_OBJECT, "TaskStore", &g_define_type_info, 0);
		g_type_add_interface_static (task_store_type_id, TYPE_DRAG_LIST_MODEL, &drag_list_model_info);
		g_once_init_leave (&task_store_type_id__volatile, task_store_type_id);
	}
	return task_store_type_id__volatile;
}


static void _vala_task_store_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TaskStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TASK_STORE, TaskStore);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	switch (property_id) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		case TASK_STORE_DONE_BY_DEFAULT_PROPERTY:
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		g_value_set_boolean (value, task_store_get_done_by_default (self));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		break;
#line 547 "TaskStore.c"
		default:
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		break;
#line 553 "TaskStore.c"
	}
}


static void _vala_task_store_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TaskStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TASK_STORE, TaskStore);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
	switch (property_id) {
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		case TASK_STORE_DONE_BY_DEFAULT_PROPERTY:
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		task_store_set_done_by_default (self, g_value_get_boolean (value));
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		break;
#line 569 "TaskStore.c"
		default:
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/TaskStore.vala"
		break;
#line 575 "TaskStore.c"
	}
}



