/* DragList.c generated by valac 0.38.8, the Vala compiler
 * generated from DragList.vala, do not modify */

/* Copyright 2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <string.h>


#define TYPE_DRAG_LIST (drag_list_get_type ())
#define DRAG_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAG_LIST, DragList))
#define DRAG_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAG_LIST, DragListClass))
#define IS_DRAG_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAG_LIST))
#define IS_DRAG_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAG_LIST))
#define DRAG_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAG_LIST, DragListClass))

typedef struct _DragList DragList;
typedef struct _DragListClass DragListClass;
typedef struct _DragListPrivate DragListPrivate;

#define TYPE_DRAG_LIST_ROW (drag_list_row_get_type ())
#define DRAG_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAG_LIST_ROW, DragListRow))
#define DRAG_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAG_LIST_ROW, DragListRowClass))
#define IS_DRAG_LIST_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAG_LIST_ROW))
#define IS_DRAG_LIST_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAG_LIST_ROW))
#define DRAG_LIST_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAG_LIST_ROW, DragListRowClass))

typedef struct _DragListRow DragListRow;
typedef struct _DragListRowClass DragListRowClass;

#define TYPE_DRAG_LIST_MODEL (drag_list_model_get_type ())
#define DRAG_LIST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAG_LIST_MODEL, DragListModel))
#define IS_DRAG_LIST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAG_LIST_MODEL))
#define DRAG_LIST_MODEL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DRAG_LIST_MODEL, DragListModelIface))

typedef struct _DragListModel DragListModel;
typedef struct _DragListModelIface DragListModelIface;

#define TYPE_INT_RANGE (int_range_get_type ())
typedef struct _IntRange IntRange;
enum  {
	DRAG_LIST_0_PROPERTY,
	DRAG_LIST_VADJUSTMENT_PROPERTY,
	DRAG_LIST_NUM_PROPERTIES
};
static GParamSpec* drag_list_properties[DRAG_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	DRAG_LIST_ACTIVATE_CURSOR_ROW_SIGNAL,
	DRAG_LIST_ROW_ACTIVATED_SIGNAL,
	DRAG_LIST_MOVE_CURSOR_SIGNAL,
	DRAG_LIST_ROW_SELECTED_SIGNAL,
	DRAG_LIST_ROW_RECEIVED_WITH_MODEL_SIGNAL,
	DRAG_LIST_NUM_SIGNALS
};
static guint drag_list_signals[DRAG_LIST_NUM_SIGNALS] = {0};
typedef struct _DragListRowPrivate DragListRowPrivate;
enum  {
	DRAG_LIST_ROW_0_PROPERTY,
	DRAG_LIST_ROW_NUM_PROPERTIES
};
static GParamSpec* drag_list_row_properties[DRAG_LIST_ROW_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DragListModelIface {
	GTypeInterface parent_iface;
	void (*move_item) (DragListModel* self, guint old_position, guint new_position);
	GObject* (*get_item) (DragListModel* self, guint position);
	GType (*get_item_type) (DragListModel* self);
	guint (*get_n_items) (DragListModel* self);
};

struct _DragList {
	GtkBin parent_instance;
	DragListPrivate * priv;
	DragListModel* model;
	DragListRow* drag_row;
};

struct _DragListClass {
	GtkBinClass parent_class;
	void (*activate_cursor_row) (DragList* self);
	void (*row_activated) (DragList* self, DragListRow* row);
	void (*move_cursor) (DragList* self, GtkMovementStep step, gint count);
	void (*row_selected) (DragList* self, DragListRow* row);
	void (*row_received_with_model) (DragList* self, DragListRow* row, gint index);
};

typedef GtkWidget* (*DragListCreateWidgetFunc) (GObject* item, void* user_data);
struct _IntRange {
	gint min;
	gint max;
};

struct _DragListPrivate {
	GtkListBox* listbox;
	DragListCreateWidgetFunc create_widget_func;
	gpointer create_widget_func_target;
	GDestroyNotify create_widget_func_target_destroy_notify;
	DragListRow* hover_row_top;
	DragListRow* hover_row_bottom;
	gboolean should_scroll;
	gboolean scrolling;
	gboolean scroll_up;
	gboolean ranges_set;
	IntRange input_range;
	IntRange drag_row_range;
	IntRange current_hover_range;
	gboolean internal_signal;
	gboolean block_row_selected;
};

typedef gboolean (*DragListFilterFunc) (DragListRow* row, void* user_data);
struct _Block2Data {
	int _ref_count_;
	DragList* self;
	DragListFilterFunc filter_func;
	gpointer filter_func_target;
};

struct _DragListRow {
	GtkListBoxRow parent_instance;
	DragListRowPrivate * priv;
};

struct _DragListRowClass {
	GtkListBoxRowClass parent_class;
};

struct _DragListRowPrivate {
	GtkEventBox* handle;
	GtkBox* layout;
	GtkImage* image;
	GtkWidget* start_widget;
	GtkWidget* center_widget;
};


static gpointer drag_list_parent_class = NULL;
static gpointer drag_list_row_parent_class = NULL;

GType drag_list_get_type (void) G_GNUC_CONST;
GType drag_list_row_get_type (void) G_GNUC_CONST;
GType drag_list_model_get_type (void) G_GNUC_CONST;
GType int_range_get_type (void) G_GNUC_CONST;
IntRange* int_range_dup (const IntRange* self);
void int_range_free (IntRange* self);
#define DRAG_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DRAG_LIST, DragListPrivate))
#define DRAG_LIST_SCROLL_STEP_SIZE 8
#define DRAG_LIST_SCROLL_DISTANCE 30
#define DRAG_LIST_SCROLL_DELAY 50
static void drag_list_on_list_row_activated (DragList* self, GtkListBoxRow* row);
static void drag_list_on_list_move_cursor (DragList* self, GtkMovementStep step, gint count);
static void drag_list_on_list_row_selected (DragList* self, GtkListBoxRow* row);
DragList* drag_list_new (void);
DragList* drag_list_construct (GType object_type);
static void drag_list_connect_signals (DragList* self);
static void _drag_list_on_list_move_cursor_gtk_list_box_move_cursor (GtkListBox* _sender, GtkMovementStep step, gint count, gpointer self);
static void _drag_list_on_list_row_activated_gtk_list_box_row_activated (GtkListBox* _sender, GtkListBoxRow* row, gpointer self);
static void _drag_list_on_list_row_selected_gtk_list_box_row_selected (GtkListBox* _sender, GtkListBoxRow* row, gpointer self);
static gboolean drag_list_on_list_drag_motion (DragList* self, GdkDragContext* context, gint x, gint y, guint time_);
static gboolean _drag_list_on_list_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self);
static void drag_list_on_list_drag_leave (DragList* self, GdkDragContext* context, guint time_);
static void _drag_list_on_list_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender, GdkDragContext* context, guint time_, gpointer self);
static void drag_list_on_list_drag_data_received (DragList* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_);
static void _drag_list_on_list_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_, gpointer self);
void drag_list_bind_model (DragList* self, DragListModel* model, DragListCreateWidgetFunc create_widget_func, void* create_widget_func_target, GDestroyNotify create_widget_func_target_destroy_notify);
static void drag_list_disconnect_model_signals (DragList* self);
static void __lambda7_ (DragList* self, GtkWidget* widget);
static void ___lambda7__gtk_callback (GtkWidget* widget, gpointer self);
guint drag_list_model_get_n_items (DragListModel* self);
GObject* drag_list_model_get_item (DragListModel* self, guint position);
static inline void _drag_list_add_row (DragList* self, GtkWidget* widget);
static void drag_list_on_model_items_changed (DragList* self, guint index, guint removed, guint added);
static void _drag_list_on_model_items_changed_drag_list_model_items_changed (DragListModel* _sender, guint position, guint removed, guint added, gpointer self);
static void drag_list_on_model_item_moved (DragList* self, guint old_index, guint new_index);
static void _drag_list_on_model_item_moved_drag_list_model_item_moved (DragListModel* _sender, guint old_position, guint new_position, gpointer self);
DragListRow* drag_list_get_selected_row (DragList* self);
DragListRow* drag_list_get_row_at_index (DragList* self, gint index);
static void _drag_list_insert_row (DragList* self, GtkWidget* widget, gint position);
static void drag_list_select_closest_to (DragList* self, gint index);
static void _drag_list_move_row (DragList* self, DragListRow* row, gint index, gboolean relative);
void drag_list_select_row (DragList* self, DragListRow* row);
void drag_list_add_row (DragList* self, GtkWidget* widget);
void drag_list_insert_row (DragList* self, GtkWidget* widget, gint position);
DragListRow* drag_list_row_new (void);
DragListRow* drag_list_row_construct (GType object_type);
void drag_list_row_set_center_widget (DragListRow* self, GtkWidget* widget);
void drag_list_remove_row (DragList* self, DragListRow* row);
GList* drag_list_get_rows (DragList* self);
void drag_list_move_row (DragList* self, DragListRow* row, gint index);
void drag_list_model_move_item (DragListModel* self, guint old_position, guint new_position);
void drag_list_set_filter_func (DragList* self, DragListFilterFunc filter_func, void* filter_func_target);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda8_ (Block2Data* _data2_, GtkListBoxRow* row);
static gboolean ___lambda8__gtk_list_box_filter_func (GtkListBoxRow* row, gpointer self);
void drag_list_invalidate_filter (DragList* self);
static void drag_list_set_ranges (DragList* self);
static void drag_list_set_drag_row_range (DragList* self);
static gint drag_list_get_widget_middle (DragList* self, GtkWidget* widget);
gint int_range_clamp (IntRange *self, gint val);
gboolean int_range_contains (IntRange *self, gint val);
static void drag_list_remove_hover_style (DragList* self);
static void drag_list_set_hover_rows (DragList* self, gint y);
static void drag_list_add_hover_style (DragList* self);
static void drag_list_check_scroll (DragList* self, gint y);
static gboolean drag_list_scroll (DragList* self);
static gboolean _drag_list_scroll_gsource_func (gpointer self);
static void drag_list_set_hover_rows_deadzone (DragList* self);
static void drag_list_set_hover_rows_from_y (DragList* self, gint y);
static void drag_list_drag_insert_row (DragList* self, DragListRow* row, gint index);
DragList* drag_list_row_get_drag_list_box (DragListRow* self);
GtkAdjustment* drag_list_get_vadjustment (DragList* self);
void drag_list_set_vadjustment (DragList* self, GtkAdjustment* value);
static void drag_list_real_activate_cursor_row (DragList* self);
static void drag_list_real_row_activated (DragList* self, DragListRow* row);
static void drag_list_real_move_cursor (DragList* self, GtkMovementStep step, gint count);
static void g_cclosure_user_marshal_VOID__ENUM_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void drag_list_real_row_selected (DragList* self, DragListRow* row);
static void drag_list_real_row_received_with_model (DragList* self, DragListRow* row, gint index);
static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void drag_list_finalize (GObject * obj);
static void _vala_drag_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drag_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define DRAG_LIST_ROW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DRAG_LIST_ROW, DragListRowPrivate))
static void drag_list_row_handle_drag_begin (DragListRow* self, GdkDragContext* context);
static void _drag_list_row_handle_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender, GdkDragContext* context, gpointer self);
static void drag_list_row_handle_drag_data_get (DragListRow* self, GdkDragContext* context, GtkSelectionData* selection_data, guint info, guint time_);
static void _drag_list_row_handle_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender, GdkDragContext* context, GtkSelectionData* selection_data, guint info, guint time_, gpointer self);
void drag_list_row_set_start_widget (DragListRow* self, GtkWidget* widget);
GtkWidget* drag_list_row_get_start_widget (DragListRow* self);
GtkWidget* drag_list_row_get_center_widget (DragListRow* self);
static void drag_list_row_finalize (GObject * obj);

const GtkTargetEntry dlb_entries[1] = {{"DRAG_LIST_ROW", (guint) GTK_TARGET_SAME_APP, (guint) 0}};

static void drag_list_on_list_row_activated (DragList* self, GtkListBoxRow* row) {
	GtkListBoxRow* _tmp0_;
#line 79 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 79 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = row;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_emit (self, drag_list_signals[DRAG_LIST_ROW_ACTIVATED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DRAG_LIST_ROW, DragListRow));
#line 278 "DragList.c"
}


static void drag_list_on_list_move_cursor (DragList* self, GtkMovementStep step, gint count) {
	gboolean _tmp0_;
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->internal_signal;
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (!_tmp0_) {
#line 290 "DragList.c"
		GtkMovementStep _tmp1_;
		gint _tmp2_;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = step;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = count;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_signal_emit (self, drag_list_signals[DRAG_LIST_MOVE_CURSOR_SIGNAL], 0, _tmp1_, _tmp2_);
#line 299 "DragList.c"
	}
}


static void drag_list_on_list_row_selected (DragList* self, GtkListBoxRow* row) {
	gboolean _tmp0_;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->block_row_selected;
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (!_tmp0_) {
#line 312 "DragList.c"
		GtkListBoxRow* _tmp1_;
#line 107 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = row;
#line 107 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_signal_emit (self, drag_list_signals[DRAG_LIST_ROW_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DRAG_LIST_ROW, DragListRow));
#line 318 "DragList.c"
	}
}


DragList* drag_list_construct (GType object_type) {
	DragList * self = NULL;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
#line 122 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self = (DragList*) g_object_new (object_type, NULL);
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = (GtkListBox*) gtk_list_box_new ();
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_object_ref_sink (_tmp0_);
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->listbox);
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->listbox = _tmp0_;
#line 124 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = self->priv->listbox;
#line 124 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_list_box_set_selection_mode (_tmp1_, GTK_SELECTION_BROWSE);
#line 125 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = self->priv->listbox;
#line 125 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_list_box_set_activate_on_single_click (_tmp2_, FALSE);
#line 126 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = self->priv->listbox;
#line 126 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_drag_dest_set ((GtkWidget*) _tmp3_, GTK_DEST_DEFAULT_ALL, dlb_entries, G_N_ELEMENTS (dlb_entries), GDK_ACTION_MOVE);
#line 130 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->internal_signal = FALSE;
#line 131 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->block_row_selected = FALSE;
#line 133 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = self->priv->listbox;
#line 133 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
#line 134 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_connect_signals (self);
#line 122 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return self;
#line 364 "DragList.c"
}


DragList* drag_list_new (void) {
#line 122 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return drag_list_construct (TYPE_DRAG_LIST);
#line 371 "DragList.c"
}


static void _drag_list_on_list_move_cursor_gtk_list_box_move_cursor (GtkListBox* _sender, GtkMovementStep step, gint count, gpointer self) {
#line 138 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_on_list_move_cursor ((DragList*) self, step, count);
#line 378 "DragList.c"
}


static void _drag_list_on_list_row_activated_gtk_list_box_row_activated (GtkListBox* _sender, GtkListBoxRow* row, gpointer self) {
#line 139 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_on_list_row_activated ((DragList*) self, row);
#line 385 "DragList.c"
}


static void _drag_list_on_list_row_selected_gtk_list_box_row_selected (GtkListBox* _sender, GtkListBoxRow* row, gpointer self) {
#line 140 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_on_list_row_selected ((DragList*) self, row);
#line 392 "DragList.c"
}


static gboolean _drag_list_on_list_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self) {
	gboolean result;
	result = drag_list_on_list_drag_motion ((DragList*) self, context, x, y, time_);
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 401 "DragList.c"
}


static void _drag_list_on_list_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender, GdkDragContext* context, guint time_, gpointer self) {
#line 142 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_on_list_drag_leave ((DragList*) self, context, time_);
#line 408 "DragList.c"
}


static void _drag_list_on_list_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_, gpointer self) {
#line 143 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_on_list_drag_data_received ((DragList*) self, context, x, y, selection_data, info, time_);
#line 415 "DragList.c"
}


static void drag_list_connect_signals (DragList* self) {
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
#line 137 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 138 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 138 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object (_tmp0_, "move-cursor", (GCallback) _drag_list_on_list_move_cursor_gtk_list_box_move_cursor, self, 0);
#line 139 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = self->priv->listbox;
#line 139 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object (_tmp1_, "row-activated", (GCallback) _drag_list_on_list_row_activated_gtk_list_box_row_activated, self, G_CONNECT_AFTER);
#line 140 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = self->priv->listbox;
#line 140 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object (_tmp2_, "row-selected", (GCallback) _drag_list_on_list_row_selected_gtk_list_box_row_selected, self, 0);
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = self->priv->listbox;
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp3_, "drag-motion", (GCallback) _drag_list_on_list_drag_motion_gtk_widget_drag_motion, self, 0);
#line 142 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = self->priv->listbox;
#line 142 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp4_, "drag-leave", (GCallback) _drag_list_on_list_drag_leave_gtk_widget_drag_leave, self, 0);
#line 143 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = self->priv->listbox;
#line 143 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp5_, "drag-data-received", (GCallback) _drag_list_on_list_drag_data_received_gtk_widget_drag_data_received, self, 0);
#line 452 "DragList.c"
}


/**
     * Binds model to this.
     *
     * If this was already bound to a model, that previous binding is destroyed.
     *
     * The contents of this are cleared and then filled with widgets that
     * represent items from model. this is updated whenever model changes.
     *
     * If model is null, this is left empty.
     *
     * It is undefined to add, remove or move widgets directly
     * (for example, with insert_row or add_row) while this is bound to a model.
     *
     * @paran model the DragListModel to be bound to this
     * @param create_widget_func a function that creates Widgets for items or null in
     * case you also passed null as model
     */
static void __lambda7_ (DragList* self, GtkWidget* widget) {
	GtkWidget* _tmp0_;
#line 171 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 172 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = widget;
#line 172 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_container_remove ((GtkContainer*) self, _tmp0_);
#line 481 "DragList.c"
}


static void ___lambda7__gtk_callback (GtkWidget* widget, gpointer self) {
#line 171 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	__lambda7_ ((DragList*) self, widget);
#line 488 "DragList.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return self ? g_object_ref (self) : NULL;
#line 495 "DragList.c"
}


static void _drag_list_on_model_items_changed_drag_list_model_items_changed (DragListModel* _sender, guint position, guint removed, guint added, gpointer self) {
#line 187 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_on_model_items_changed ((DragList*) self, position, removed, added);
#line 502 "DragList.c"
}


static void _drag_list_on_model_item_moved_drag_list_model_item_moved (DragListModel* _sender, guint old_position, guint new_position, gpointer self) {
#line 188 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_on_model_item_moved ((DragList*) self, old_position, new_position);
#line 509 "DragList.c"
}


void drag_list_bind_model (DragList* self, DragListModel* model, DragListCreateWidgetFunc create_widget_func, void* create_widget_func_target, GDestroyNotify create_widget_func_target_destroy_notify) {
	DragListModel* _tmp0_;
	GtkListBox* _tmp2_;
	DragListModel* _tmp3_;
	DragListModel* _tmp4_;
	DragListCreateWidgetFunc _tmp5_;
	void* _tmp5__target;
	GDestroyNotify _tmp5__target_destroy_notify;
	DragListModel* _tmp6_;
	DragListModel* _tmp20_;
	DragListModel* _tmp21_;
#line 163 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 166 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = model;
#line 166 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ == NULL) {
#line 530 "DragList.c"
		DragListCreateWidgetFunc _tmp1_;
		void* _tmp1__target;
#line 167 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = create_widget_func;
#line 167 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1__target = create_widget_func_target;
#line 167 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_vala_assert (_tmp1_ == NULL, "create_widget_func == null");
#line 539 "DragList.c"
	}
#line 170 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_disconnect_model_signals (self);
#line 171 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = self->priv->listbox;
#line 171 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_container_foreach ((GtkContainer*) _tmp2_, ___lambda7__gtk_callback, self);
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = model;
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->model);
#line 175 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->model = _tmp4_;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = create_widget_func;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5__target = create_widget_func_target;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5__target_destroy_notify = create_widget_func_target_destroy_notify;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	create_widget_func = NULL;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	create_widget_func_target = NULL;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	create_widget_func_target_destroy_notify = NULL;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	(self->priv->create_widget_func_target_destroy_notify == NULL) ? NULL : (self->priv->create_widget_func_target_destroy_notify (self->priv->create_widget_func_target), NULL);
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func = NULL;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func_target = NULL;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func_target_destroy_notify = NULL;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func = _tmp5_;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func_target = _tmp5__target;
#line 176 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func_target_destroy_notify = _tmp5__target_destroy_notify;
#line 178 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp6_ = self->model;
#line 178 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp6_ == NULL) {
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		(create_widget_func_target_destroy_notify == NULL) ? NULL : (create_widget_func_target_destroy_notify (create_widget_func_target), NULL);
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		create_widget_func = NULL;
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		create_widget_func_target = NULL;
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		create_widget_func_target_destroy_notify = NULL;
#line 179 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		return;
#line 595 "DragList.c"
	}
	{
		guint i = 0U;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		i = (guint) 0;
#line 601 "DragList.c"
		{
			gboolean _tmp7_ = FALSE;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp7_ = TRUE;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			while (TRUE) {
#line 608 "DragList.c"
				guint _tmp9_;
				DragListModel* _tmp10_;
				guint _tmp11_;
				GtkWidget* row = NULL;
				DragListCreateWidgetFunc _tmp12_;
				void* _tmp12__target;
				DragListModel* _tmp13_;
				guint _tmp14_;
				GObject* _tmp15_;
				GObject* _tmp16_;
				GtkWidget* _tmp17_;
				GtkWidget* _tmp18_;
				GtkWidget* _tmp19_;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				if (!_tmp7_) {
#line 624 "DragList.c"
					guint _tmp8_;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					_tmp8_ = i;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					i = _tmp8_ + 1;
#line 630 "DragList.c"
				}
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp7_ = FALSE;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp9_ = i;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp10_ = model;
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp11_ = drag_list_model_get_n_items (_tmp10_);
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				if (!(_tmp9_ < _tmp11_)) {
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					break;
#line 644 "DragList.c"
				}
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp12_ = self->priv->create_widget_func;
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp12__target = self->priv->create_widget_func_target;
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp13_ = model;
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp14_ = i;
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp15_ = drag_list_model_get_item (_tmp13_, _tmp14_);
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp16_ = _tmp15_;
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp17_ = _tmp12_ (_tmp16_, _tmp12__target);
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp18_ = _tmp17_;
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_g_object_unref0 (_tmp16_);
#line 183 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				row = _tmp18_;
#line 184 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp19_ = row;
#line 184 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_drag_list_add_row (self, _tmp19_);
#line 182 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_g_object_unref0 (row);
#line 672 "DragList.c"
			}
		}
	}
#line 187 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp20_ = model;
#line 187 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object (_tmp20_, "items-changed", (GCallback) _drag_list_on_model_items_changed_drag_list_model_items_changed, self, 0);
#line 188 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp21_ = model;
#line 188 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object (_tmp21_, "item-moved", (GCallback) _drag_list_on_model_item_moved_drag_list_model_item_moved, self, 0);
#line 163 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	(create_widget_func_target_destroy_notify == NULL) ? NULL : (create_widget_func_target_destroy_notify (create_widget_func_target), NULL);
#line 163 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	create_widget_func = NULL;
#line 163 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	create_widget_func_target = NULL;
#line 163 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	create_widget_func_target_destroy_notify = NULL;
#line 692 "DragList.c"
}


static void drag_list_disconnect_model_signals (DragList* self) {
	DragListModel* _tmp0_;
#line 191 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 192 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->model;
#line 192 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 704 "DragList.c"
		DragListModel* _tmp1_;
		guint _tmp2_;
		DragListModel* _tmp3_;
		guint _tmp4_;
#line 193 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = self->model;
#line 193 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_signal_parse_name ("items-changed", TYPE_DRAG_LIST_MODEL, &_tmp2_, NULL, FALSE);
#line 193 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _drag_list_on_model_items_changed_drag_list_model_items_changed, self);
#line 194 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp3_ = self->model;
#line 194 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_signal_parse_name ("item-moved", TYPE_DRAG_LIST_MODEL, &_tmp4_, NULL, FALSE);
#line 194 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _drag_list_on_model_item_moved_drag_list_model_item_moved, self);
#line 721 "DragList.c"
	}
}


static void drag_list_on_model_items_changed (DragList* self, guint index, guint removed, guint added) {
	gboolean need_to_select_closest = FALSE;
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	guint _tmp26_;
	gboolean _tmp41_;
#line 198 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 199 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	need_to_select_closest = FALSE;
#line 200 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->block_row_selected = TRUE;
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = removed;
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp1_ > ((guint) 0)) {
#line 742 "DragList.c"
		guint _tmp2_;
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = added;
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp0_ = _tmp2_ == ((guint) 0);
#line 748 "DragList.c"
	} else {
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp0_ = FALSE;
#line 752 "DragList.c"
	}
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_) {
#line 756 "DragList.c"
		DragListRow* selected_row = NULL;
		DragListRow* _tmp3_;
		DragListRow* _tmp4_;
		DragListRow* _tmp5_;
		guint selected_index = 0U;
		DragListRow* _tmp6_;
		gint _tmp7_;
		gboolean _tmp8_ = FALSE;
		guint _tmp9_;
		guint _tmp10_;
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp3_ = drag_list_get_selected_row (self);
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 202 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		selected_row = _tmp4_;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp5_ = selected_row;
#line 203 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_vala_assert (_tmp5_ != NULL, "selected_row != null");
#line 204 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp6_ = selected_row;
#line 204 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp7_ = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp6_);
#line 204 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		selected_index = (guint) _tmp7_;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp9_ = index;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp10_ = selected_index;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp9_ <= _tmp10_) {
#line 789 "DragList.c"
			guint _tmp11_;
			guint _tmp12_;
			guint _tmp13_;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp11_ = index;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp12_ = removed;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp13_ = selected_index;
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp8_ = (_tmp11_ + _tmp12_) > _tmp13_;
#line 801 "DragList.c"
		} else {
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp8_ = FALSE;
#line 805 "DragList.c"
		}
#line 205 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		need_to_select_closest = _tmp8_;
#line 201 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (selected_row);
#line 811 "DragList.c"
	}
	{
		guint i = 0U;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		i = (guint) 0;
#line 817 "DragList.c"
		{
			gboolean _tmp14_ = FALSE;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp14_ = TRUE;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			while (TRUE) {
#line 824 "DragList.c"
				guint _tmp16_;
				guint _tmp17_;
				DragListRow* row = NULL;
				guint _tmp18_;
				DragListRow* _tmp19_;
				GtkListBox* _tmp20_;
				DragListRow* _tmp21_;
				DragListRow* _tmp22_;
				gboolean _tmp23_;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				if (!_tmp14_) {
#line 836 "DragList.c"
					guint _tmp15_;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					_tmp15_ = i;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					i = _tmp15_ + 1;
#line 842 "DragList.c"
				}
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp14_ = FALSE;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp16_ = i;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp17_ = removed;
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				if (!(_tmp16_ < _tmp17_)) {
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					break;
#line 854 "DragList.c"
				}
#line 208 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp18_ = index;
#line 208 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp19_ = drag_list_get_row_at_index (self, (gint) _tmp18_);
#line 208 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				row = _tmp19_;
#line 209 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp20_ = self->priv->listbox;
#line 209 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp21_ = row;
#line 209 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				gtk_container_remove ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 214 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp22_ = row;
#line 214 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp23_ = gtk_list_box_row_is_selected ((GtkListBoxRow*) _tmp22_);
#line 214 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				if (_tmp23_) {
#line 874 "DragList.c"
					DragListRow* _tmp24_;
					DragListRow* _tmp25_;
#line 215 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					_tmp24_ = row;
#line 215 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					gtk_list_box_row_set_selectable ((GtkListBoxRow*) _tmp24_, FALSE);
#line 216 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					_tmp25_ = row;
#line 216 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					gtk_list_box_row_set_selectable ((GtkListBoxRow*) _tmp25_, TRUE);
#line 885 "DragList.c"
				}
#line 207 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_g_object_unref0 (row);
#line 889 "DragList.c"
			}
		}
	}
#line 219 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp26_ = added;
#line 219 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp26_ > ((guint) 0)) {
#line 220 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->block_row_selected = FALSE;
#line 899 "DragList.c"
	}
	{
		guint i = 0U;
		guint _tmp27_;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp27_ = index;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		i = _tmp27_;
#line 908 "DragList.c"
		{
			gboolean _tmp28_ = FALSE;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp28_ = TRUE;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			while (TRUE) {
#line 915 "DragList.c"
				guint _tmp30_;
				guint _tmp31_;
				guint _tmp32_;
				DragListCreateWidgetFunc _tmp33_;
				void* _tmp33__target;
				DragListModel* _tmp34_;
				guint _tmp35_;
				GObject* _tmp36_;
				GObject* _tmp37_;
				GtkWidget* _tmp38_;
				GtkWidget* _tmp39_;
				guint _tmp40_;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				if (!_tmp28_) {
#line 930 "DragList.c"
					guint _tmp29_;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					_tmp29_ = i;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					i = _tmp29_ + 1;
#line 936 "DragList.c"
				}
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp28_ = FALSE;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp30_ = i;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp31_ = index;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp32_ = added;
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				if (!(_tmp30_ < (_tmp31_ + _tmp32_))) {
#line 222 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
					break;
#line 950 "DragList.c"
				}
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp33_ = self->priv->create_widget_func;
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp33__target = self->priv->create_widget_func_target;
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp34_ = self->model;
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp35_ = i;
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp36_ = drag_list_model_get_item (_tmp34_, _tmp35_);
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp37_ = _tmp36_;
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp38_ = _tmp33_ (_tmp37_, _tmp33__target);
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp39_ = _tmp38_;
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp40_ = i;
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_drag_list_insert_row (self, _tmp39_, (gint) _tmp40_);
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_g_object_unref0 (_tmp39_);
#line 223 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_g_object_unref0 (_tmp37_);
#line 976 "DragList.c"
			}
		}
	}
#line 225 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp41_ = need_to_select_closest;
#line 225 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp41_) {
#line 984 "DragList.c"
		guint _tmp42_;
#line 226 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp42_ = index;
#line 226 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_select_closest_to (self, (gint) _tmp42_);
#line 227 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->block_row_selected = FALSE;
#line 992 "DragList.c"
	}
}


static void drag_list_on_model_item_moved (DragList* self, guint old_index, guint new_index) {
	guint _tmp0_;
	DragListRow* _tmp1_;
	DragListRow* _tmp2_;
	guint _tmp3_;
#line 231 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 232 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = old_index;
#line 232 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = drag_list_get_row_at_index (self, (gint) _tmp0_);
#line 232 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DRAG_LIST_ROW, DragListRow);
#line 232 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = new_index;
#line 232 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_drag_list_move_row (self, _tmp2_, (gint) _tmp3_, FALSE);
#line 232 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (_tmp2_);
#line 1016 "DragList.c"
}


/**
     * Returns the currently selected row.
     */
DragListRow* drag_list_get_selected_row (DragList* self) {
	DragListRow* result = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
#line 240 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 241 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 241 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DRAG_LIST_ROW, DragListRow);
#line 241 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 1037 "DragList.c"
}


/**
     * Make row the currently selected row.
     *
     * @param row DragListRow to select
     */
void drag_list_select_row (DragList* self, DragListRow* row) {
	GtkListBox* _tmp0_;
	DragListRow* _tmp1_;
#line 249 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 249 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 250 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 250 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = row;
#line 250 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_list_box_select_row (_tmp0_, (GtkListBoxRow*) _tmp1_);
#line 1059 "DragList.c"
}


/**
     * Used to select a row after the selected row was removed
     */
static void drag_list_select_closest_to (DragList* self, gint index) {
	DragListRow* next = NULL;
	gint _tmp0_;
	DragListRow* _tmp1_;
	DragListRow* _tmp2_;
	GtkListBox* _tmp5_;
	DragListRow* _tmp6_;
	DragListRow* _tmp7_;
#line 256 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 257 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = index;
#line 257 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = drag_list_get_row_at_index (self, _tmp0_);
#line 257 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	next = _tmp1_;
#line 258 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = next;
#line 258 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp2_ == NULL) {
#line 1086 "DragList.c"
		gint _tmp3_;
		DragListRow* _tmp4_;
#line 259 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp3_ = index;
#line 259 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = drag_list_get_row_at_index (self, _tmp3_ - 1);
#line 259 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (next);
#line 259 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		next = _tmp4_;
#line 1097 "DragList.c"
	}
#line 261 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = self->priv->listbox;
#line 261 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp6_ = next;
#line 261 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_list_box_select_row (_tmp5_, (GtkListBoxRow*) _tmp6_);
#line 262 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp7_ = next;
#line 262 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_emit (self, drag_list_signals[DRAG_LIST_ROW_SELECTED_SIGNAL], 0, _tmp7_);
#line 256 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (next);
#line 1111 "DragList.c"
}


void drag_list_add_row (DragList* self, GtkWidget* widget) {
	GtkWidget* _tmp0_;
#line 265 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 265 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = widget;
#line 266 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_insert_row (self, _tmp0_, -1);
#line 1125 "DragList.c"
}


static inline void _drag_list_add_row (DragList* self, GtkWidget* widget) {
	GtkWidget* _tmp0_;
#line 269 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 269 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 270 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = widget;
#line 270 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_drag_list_insert_row (self, _tmp0_, -1);
#line 1139 "DragList.c"
}


/**
     * Insert the widget into the this at position.
     *
     * If position is -1, or larger than the total number of items in the this, then the child will be appended to the end.
     *
     * @param widget the Widget to add
     * @param position the position to insert child in
     */
void drag_list_insert_row (DragList* self, GtkWidget* widget, gint position) {
	DragListModel* _tmp0_;
#line 281 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 281 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->model;
#line 282 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ == NULL) {
#line 1161 "DragList.c"
		GtkWidget* _tmp1_;
		gint _tmp2_;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = widget;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = position;
#line 283 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_drag_list_insert_row (self, _tmp1_, _tmp2_);
#line 1170 "DragList.c"
	}
}


static void _drag_list_insert_row (DragList* self, GtkWidget* widget, gint position) {
	DragListRow* row = NULL;
	GtkWidget* _tmp0_;
	DragListRow* _tmp1_;
	DragListRow* _tmp2_;
	GtkListBox* _tmp6_;
	DragListRow* _tmp7_;
	gint _tmp8_;
	GtkListBox* _tmp9_;
	GtkListBoxRow* _tmp10_;
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 288 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = widget;
#line 288 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_DRAG_LIST_ROW) ? ((DragListRow*) _tmp0_) : NULL);
#line 288 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	row = _tmp1_;
#line 290 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = row;
#line 290 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp2_ == NULL) {
#line 1199 "DragList.c"
		DragListRow* _tmp3_;
		DragListRow* _tmp4_;
		GtkWidget* _tmp5_;
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp3_ = drag_list_row_new ();
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_object_ref_sink (_tmp3_);
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (row);
#line 291 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		row = _tmp3_;
#line 292 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = row;
#line 292 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp5_ = widget;
#line 292 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_row_set_center_widget (_tmp4_, _tmp5_);
#line 1217 "DragList.c"
	}
#line 295 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp6_ = self->priv->listbox;
#line 295 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp7_ = row;
#line 295 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp8_ = position;
#line 295 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_list_box_insert (_tmp6_, (GtkWidget*) _tmp7_, _tmp8_);
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp9_ = self->priv->listbox;
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp10_ = gtk_list_box_get_selected_row (_tmp9_);
#line 296 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp10_ == NULL) {
#line 1233 "DragList.c"
		GtkListBox* _tmp11_;
		DragListRow* _tmp12_;
		GtkListBox* _tmp13_;
		GtkListBoxRow* _tmp14_;
		DragListRow* _tmp15_;
#line 297 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp11_ = self->priv->listbox;
#line 297 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp12_ = row;
#line 297 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_list_box_select_row (_tmp11_, (GtkListBoxRow*) _tmp12_);
#line 298 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp13_ = self->priv->listbox;
#line 298 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp14_ = gtk_list_box_get_selected_row (_tmp13_);
#line 298 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp15_ = row;
#line 298 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_vala_assert (_tmp14_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_list_box_row_get_type (), GtkListBoxRow), "listbox.get_selected_row () == row");
#line 1253 "DragList.c"
	}
#line 287 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (row);
#line 1257 "DragList.c"
}


void drag_list_remove_row (DragList* self, DragListRow* row) {
	DragListModel* _tmp0_;
	DragListRow* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBoxRow* _tmp3_;
#line 302 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 302 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 303 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->model;
#line 303 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_vala_assert (_tmp0_ == NULL, "model == null");
#line 304 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = row;
#line 304 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = self->priv->listbox;
#line 304 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = gtk_list_box_get_selected_row (_tmp2_);
#line 304 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_list_box_row_get_type (), GtkListBoxRow) == _tmp3_) {
#line 1282 "DragList.c"
		gint index = 0;
		DragListRow* _tmp4_;
		gint _tmp5_;
		GtkListBox* _tmp6_;
		DragListRow* _tmp7_;
		gint _tmp8_;
		DragListRow* _tmp9_;
		gboolean _tmp10_;
#line 305 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->block_row_selected = TRUE;
#line 306 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = row;
#line 306 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp5_ = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp4_);
#line 306 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		index = _tmp5_;
#line 307 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp6_ = self->priv->listbox;
#line 307 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp7_ = row;
#line 307 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 308 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp8_ = index;
#line 308 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_select_closest_to (self, _tmp8_);
#line 313 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp9_ = row;
#line 313 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp10_ = gtk_list_box_row_is_selected ((GtkListBoxRow*) _tmp9_);
#line 313 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp10_) {
#line 1315 "DragList.c"
			DragListRow* _tmp11_;
			DragListRow* _tmp12_;
#line 314 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp11_ = row;
#line 314 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			gtk_list_box_row_set_selectable ((GtkListBoxRow*) _tmp11_, FALSE);
#line 315 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp12_ = row;
#line 315 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			gtk_list_box_row_set_selectable ((GtkListBoxRow*) _tmp12_, TRUE);
#line 1326 "DragList.c"
		}
#line 318 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->block_row_selected = FALSE;
#line 1330 "DragList.c"
	} else {
		GtkListBox* _tmp13_;
		DragListRow* _tmp14_;
#line 320 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp13_ = self->priv->listbox;
#line 320 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp14_ = row;
#line 320 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 1340 "DragList.c"
	}
}


/**
     * Returns all rows contained in this.
     */
GList* drag_list_get_rows (DragList* self) {
	GList* result = NULL;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
#line 327 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 328 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 328 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 328 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = (GList*) _tmp1_;
#line 328 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 1362 "DragList.c"
}


/**
     * Moves row to index.
     *
     * @param row DragListRow to be moved
     * @param index the index to move the row to
     */
void drag_list_move_row (DragList* self, DragListRow* row, gint index) {
	GtkListBox* row_parent = NULL;
	DragListRow* _tmp0_;
	GtkContainer* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
#line 337 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 337 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 338 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = row;
#line 338 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = (GtkContainer*) gtk_widget_get_parent ((GtkWidget*) _tmp0_);
#line 338 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_list_box_get_type ()) ? ((GtkListBox*) _tmp1_) : NULL);
#line 338 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	row_parent = _tmp2_;
#line 340 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = row_parent;
#line 340 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = self->priv->listbox;
#line 340 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp3_ == _tmp4_) {
#line 1397 "DragList.c"
		DragListRow* _tmp5_;
		gint _tmp6_;
#line 341 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp5_ = row;
#line 341 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp6_ = index;
#line 341 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_drag_list_move_row (self, _tmp5_, _tmp6_, FALSE);
#line 1406 "DragList.c"
	}
#line 337 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (row_parent);
#line 1410 "DragList.c"
}


static void _drag_list_move_row (DragList* self, DragListRow* row, gint index, gboolean relative) {
	gint old_index = 0;
	DragListRow* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 345 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 345 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 346 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = row;
#line 346 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp0_);
#line 346 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	old_index = _tmp1_;
#line 347 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = old_index;
#line 347 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = index;
#line 347 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp2_ != _tmp3_) {
#line 1436 "DragList.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_;
		GtkListBox* _tmp9_;
		DragListRow* _tmp10_;
		GtkListBox* _tmp11_;
		DragListRow* _tmp12_;
		gint _tmp13_;
		DragListModel* _tmp14_;
#line 348 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp5_ = relative;
#line 348 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp5_) {
#line 1449 "DragList.c"
			gint _tmp6_;
			gint _tmp7_;
#line 348 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp6_ = index;
#line 348 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp7_ = old_index;
#line 348 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp4_ = _tmp6_ > _tmp7_;
#line 1458 "DragList.c"
		} else {
#line 348 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp4_ = FALSE;
#line 1462 "DragList.c"
		}
#line 348 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp4_) {
#line 1466 "DragList.c"
			gint _tmp8_;
#line 349 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp8_ = index;
#line 349 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			index = _tmp8_ - 1;
#line 1472 "DragList.c"
		}
#line 351 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp9_ = self->priv->listbox;
#line 351 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp10_ = row;
#line 351 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 352 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp11_ = self->priv->listbox;
#line 352 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp12_ = row;
#line 352 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp13_ = index;
#line 352 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_list_box_insert (_tmp11_, (GtkWidget*) _tmp12_, _tmp13_);
#line 353 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp14_ = self->model;
#line 353 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp14_ != NULL) {
#line 1492 "DragList.c"
			gint _tmp15_;
			DragListModel* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
#line 354 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp15_ = index;
#line 354 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			if (_tmp15_ < 0) {
#line 1501 "DragList.c"
				DragListModel* _tmp16_;
				guint _tmp17_;
#line 355 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp16_ = self->model;
#line 355 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				_tmp17_ = drag_list_model_get_n_items (_tmp16_);
#line 355 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				index = ((gint) _tmp17_) - 1;
#line 1510 "DragList.c"
			}
#line 357 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp18_ = self->model;
#line 357 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp19_ = old_index;
#line 357 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp20_ = index;
#line 357 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			drag_list_model_move_item (_tmp18_, (guint) _tmp19_, (guint) _tmp20_);
#line 1520 "DragList.c"
		}
	}
}


/**
     * Gets the n-th child in the list.
     *
     * If @index is negative or larger than the number of items in the list,
     * null is returned.
     *
     * @param index the index of the row
     */
DragListRow* drag_list_get_row_at_index (DragList* self, gint index) {
	DragListRow* result = NULL;
	GtkListBox* _tmp0_;
	gint _tmp1_;
	GtkListBoxRow* _tmp2_;
	DragListRow* _tmp3_;
#line 370 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 371 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 371 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = index;
#line 371 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = gtk_list_box_get_row_at_index (_tmp0_, _tmp1_);
#line 371 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DRAG_LIST_ROW, DragListRow));
#line 371 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp3_;
#line 371 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 1554 "DragList.c"
}


/**
     * By setting a filter function on the this one can decide dynamically which
     * of the rows to show.
     *
     * For instance, to implement a search function on a list that filters the
     * original list to only show the matching rows.
     *
     * The filter_func will be called for each row after the call, and it will
     * continue to be called each time a row changes (via changed) or when
     * invalidate_filter is called.
     *
     * Unlike with Gtk.Listbox, filtering is supported when a model is bound to
     * a DragList.
     *
     * @param filter_func callback that lets you filter which rows to show
     */
static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return _data2_;
#line 1579 "DragList.c"
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1588 "DragList.c"
		DragList* self;
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self = _data2_->self;
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (self);
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_slice_free (Block2Data, _data2_);
#line 1596 "DragList.c"
	}
}


static gboolean __lambda8_ (Block2Data* _data2_, GtkListBoxRow* row) {
	DragList* self;
	gboolean result = FALSE;
	DragListFilterFunc _tmp0_;
	void* _tmp0__target;
	GtkListBoxRow* _tmp1_;
	gboolean _tmp2_;
#line 391 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self = _data2_->self;
#line 391 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (row != NULL, FALSE);
#line 392 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = _data2_->filter_func;
#line 392 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0__target = _data2_->filter_func_target;
#line 392 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = row;
#line 392 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = _tmp0_ (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DRAG_LIST_ROW, DragListRow), _tmp0__target);
#line 392 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp2_;
#line 392 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 1624 "DragList.c"
}


static gboolean ___lambda8__gtk_list_box_filter_func (GtkListBoxRow* row, gpointer self) {
	gboolean result;
	result = __lambda8_ (self, row);
#line 391 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 1633 "DragList.c"
}


void drag_list_set_filter_func (DragList* self, DragListFilterFunc filter_func, void* filter_func_target) {
	Block2Data* _data2_;
	DragListFilterFunc _tmp0_;
	void* _tmp0__target;
	GtkListBox* _tmp1_;
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_data2_->_ref_count_ = 1;
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_data2_->self = g_object_ref (self);
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = filter_func;
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0__target = filter_func_target;
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_data2_->filter_func = _tmp0_;
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_data2_->filter_func_target = _tmp0__target;
#line 391 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = self->priv->listbox;
#line 391 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_list_box_set_filter_func (_tmp1_, ___lambda8__gtk_list_box_filter_func, block2_data_ref (_data2_), block2_data_unref);
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	block2_data_unref (_data2_);
#line 390 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_data2_ = NULL;
#line 1666 "DragList.c"
}


/**
     * Update the filtering for all rows.
     *
     * Call this when result of the filter function on the this is changed due
     * to an external factor. For instance, this would be used if the filter
     * function just looked for a specific search string and the entry with the
     * search string has changed.
     */
void drag_list_invalidate_filter (DragList* self) {
	GtkListBox* _tmp0_;
#line 404 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 405 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 405 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_list_box_invalidate_filter (_tmp0_);
#line 1686 "DragList.c"
}


/**
     * Used to clamp the drag input to the area filled by the current rows to
     * make highlighting easier.
     *
     * Also sets drag_row_range to the y coordinates that would cause no change
     * when a row is dropped at those positions.
     */
static void drag_list_set_ranges (DragList* self) {
	gboolean _tmp0_;
	IntRange _tmp1_ = {0};
	IntRange _tmp2_ = {0};
	IntRange _tmp3_ = {0};
	gint last_index = 0;
	GtkListBox* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	guint _tmp7_;
	gint _tmp8_;
	DragListRow* first = NULL;
	DragListRow* _tmp9_;
	DragListRow* last = NULL;
	gint _tmp10_;
	DragListRow* _tmp11_;
	GtkAllocation alloc = {0};
	DragListRow* _tmp12_;
	GtkAllocation _tmp13_ = {0};
	GtkAllocation _tmp14_;
	gint _tmp15_;
	DragListRow* _tmp16_;
	GtkAllocation _tmp17_ = {0};
	GtkAllocation _tmp18_;
	gint _tmp19_;
	GtkAllocation _tmp20_;
	gint _tmp21_;
#line 415 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 416 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->ranges_set;
#line 416 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_) {
#line 417 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		return;
#line 1732 "DragList.c"
	}
#line 419 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_.min = 0;
#line 419 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_.max = -1;
#line 419 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->input_range = _tmp1_;
#line 420 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_.min = 0;
#line 420 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_.max = -1;
#line 420 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->current_hover_range = _tmp2_;
#line 421 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_.min = 0;
#line 421 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_.max = -1;
#line 421 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->drag_row_range = _tmp3_;
#line 423 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = self->priv->listbox;
#line 423 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = gtk_container_get_children ((GtkContainer*) _tmp4_);
#line 423 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp6_ = _tmp5_;
#line 423 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp7_ = g_list_length (_tmp6_);
#line 423 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp8_ = ((gint) _tmp7_) - 1;
#line 423 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_list_free0 (_tmp6_);
#line 423 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	last_index = _tmp8_;
#line 424 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp9_ = drag_list_get_row_at_index (self, 0);
#line 424 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	first = _tmp9_;
#line 425 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp10_ = last_index;
#line 425 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp11_ = drag_list_get_row_at_index (self, _tmp10_);
#line 425 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	last = _tmp11_;
#line 428 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp12_ = first;
#line 428 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp12_, &_tmp13_);
#line 428 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	alloc = _tmp13_;
#line 429 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp14_ = alloc;
#line 429 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp15_ = _tmp14_.y;
#line 429 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->input_range.min = _tmp15_ + 1;
#line 430 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp16_ = last;
#line 430 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp16_, &_tmp17_);
#line 430 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	alloc = _tmp17_;
#line 431 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp18_ = alloc;
#line 431 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp19_ = _tmp18_.y;
#line 431 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp20_ = alloc;
#line 431 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp21_ = _tmp20_.height;
#line 431 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->input_range.max = (_tmp19_ + _tmp21_) - 1;
#line 433 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_set_drag_row_range (self);
#line 434 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->ranges_set = TRUE;
#line 415 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (last);
#line 415 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (first);
#line 1812 "DragList.c"
}


static void drag_list_set_drag_row_range (DragList* self) {
	DragListRow* _tmp0_;
	gint drag_row_index = 0;
	DragListRow* _tmp1_;
	gint _tmp2_;
	GtkAllocation alloc = {0};
	DragListRow* _tmp3_;
	GtkAllocation _tmp4_ = {0};
	gint _tmp5_;
	GtkListBoxRow* next_row = NULL;
	GtkListBox* _tmp12_;
	gint _tmp13_;
	GtkListBoxRow* _tmp14_;
	GtkListBoxRow* _tmp15_;
	GtkListBoxRow* _tmp16_;
#line 437 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 438 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->drag_row;
#line 438 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ == NULL) {
#line 439 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		return;
#line 1839 "DragList.c"
	}
#line 442 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = self->drag_row;
#line 442 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp1_);
#line 442 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_row_index = _tmp2_;
#line 444 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = self->drag_row;
#line 444 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp3_, &_tmp4_);
#line 444 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	alloc = _tmp4_;
#line 446 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = drag_row_index;
#line 446 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp5_ >= 1) {
#line 1857 "DragList.c"
		GtkListBox* _tmp6_;
		gint _tmp7_;
		GtkListBoxRow* _tmp8_;
		gint _tmp9_;
#line 447 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp6_ = self->priv->listbox;
#line 447 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp7_ = drag_row_index;
#line 447 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp8_ = gtk_list_box_get_row_at_index (_tmp6_, _tmp7_ - 1);
#line 447 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp9_ = drag_list_get_widget_middle (self, (GtkWidget*) _tmp8_);
#line 447 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->drag_row_range.min = _tmp9_;
#line 1872 "DragList.c"
	} else {
		GtkAllocation _tmp10_;
		gint _tmp11_;
#line 451 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp10_ = alloc;
#line 451 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp11_ = _tmp10_.y;
#line 451 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->drag_row_range.min = _tmp11_;
#line 1882 "DragList.c"
	}
#line 453 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp12_ = self->priv->listbox;
#line 453 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp13_ = drag_row_index;
#line 453 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp14_ = gtk_list_box_get_row_at_index (_tmp12_, _tmp13_ + 1);
#line 453 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 453 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	next_row = _tmp15_;
#line 454 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp16_ = next_row;
#line 454 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp16_ != NULL) {
#line 1898 "DragList.c"
		GtkListBoxRow* _tmp17_;
		gint _tmp18_;
#line 455 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp17_ = next_row;
#line 455 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp18_ = drag_list_get_widget_middle (self, (GtkWidget*) _tmp17_);
#line 455 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->drag_row_range.max = _tmp18_;
#line 1907 "DragList.c"
	} else {
		GtkAllocation _tmp19_;
		gint _tmp20_;
		GtkAllocation _tmp21_;
		gint _tmp22_;
#line 457 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp19_ = alloc;
#line 457 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp20_ = _tmp19_.y;
#line 457 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp21_ = alloc;
#line 457 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp22_ = _tmp21_.height;
#line 457 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->drag_row_range.max = _tmp20_ + _tmp22_;
#line 1923 "DragList.c"
	}
#line 437 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (next_row);
#line 1927 "DragList.c"
}


static gint drag_list_get_widget_middle (DragList* self, GtkWidget* widget) {
	gint result = 0;
	GtkAllocation alloc = {0};
	GtkWidget* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	GtkAllocation _tmp2_;
	gint _tmp3_;
	GtkAllocation _tmp4_;
	gint _tmp5_;
#line 461 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 461 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (widget != NULL, 0);
#line 464 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = widget;
#line 464 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
#line 464 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	alloc = _tmp1_;
#line 465 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = alloc;
#line 465 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = _tmp2_.y;
#line 465 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = alloc;
#line 465 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = _tmp4_.height;
#line 465 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp3_ + (_tmp5_ / 2);
#line 465 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 1962 "DragList.c"
}


static gboolean _drag_list_scroll_gsource_func (gpointer self) {
	gboolean result;
	result = drag_list_scroll ((DragList*) self);
#line 482 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 1971 "DragList.c"
}


static gboolean drag_list_on_list_drag_motion (DragList* self, GdkDragContext* context, gint x, gint y, guint time_) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
#line 468 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 468 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 471 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_set_ranges (self);
#line 472 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = y;
#line 472 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = int_range_clamp (&self->priv->input_range, _tmp0_);
#line 472 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	y = _tmp1_;
#line 473 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = y;
#line 473 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = int_range_contains (&self->priv->current_hover_range, _tmp2_);
#line 473 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (!_tmp3_) {
#line 2002 "DragList.c"
		gint _tmp4_;
#line 474 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_remove_hover_style (self);
#line 475 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = y;
#line 475 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_set_hover_rows (self, _tmp4_);
#line 476 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_add_hover_style (self);
#line 2012 "DragList.c"
	}
#line 479 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = y;
#line 479 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_check_scroll (self, _tmp5_);
#line 480 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp7_ = self->priv->should_scroll;
#line 480 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp7_) {
#line 2022 "DragList.c"
		gboolean _tmp8_;
#line 480 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp8_ = self->priv->scrolling;
#line 480 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp6_ = !_tmp8_;
#line 2028 "DragList.c"
	} else {
#line 480 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp6_ = FALSE;
#line 2032 "DragList.c"
	}
#line 480 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp6_) {
#line 481 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->scrolling = TRUE;
#line 482 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) DRAG_LIST_SCROLL_DELAY, _drag_list_scroll_gsource_func, g_object_ref (self), g_object_unref);
#line 2040 "DragList.c"
	}
#line 485 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = TRUE;
#line 485 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 2046 "DragList.c"
}


/**
     * Sets current_hover_range to the range of y values that would give the
     * same result as the current y and sets hover_row_top and hover_row_bottom
     * to the rows the dragrow would be inserted between.
     */
static void drag_list_set_hover_rows (DragList* self, gint y) {
	gint _tmp0_;
	gboolean _tmp1_;
#line 493 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 494 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = y;
#line 494 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = int_range_contains (&self->priv->drag_row_range, _tmp0_);
#line 494 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp1_) {
#line 495 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_set_hover_rows_deadzone (self);
#line 2068 "DragList.c"
	} else {
		gint _tmp2_;
#line 497 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = y;
#line 497 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_set_hover_rows_from_y (self, _tmp2_);
#line 2075 "DragList.c"
	}
}


static void drag_list_set_hover_rows_deadzone (DragList* self) {
	IntRange _tmp0_;
#line 501 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 502 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_bottom);
#line 502 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->hover_row_bottom = NULL;
#line 503 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_top);
#line 503 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->hover_row_top = NULL;
#line 504 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->drag_row_range;
#line 504 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->current_hover_range = _tmp0_;
#line 2096 "DragList.c"
}


static void drag_list_set_hover_rows_from_y (DragList* self, gint y) {
	DragListRow* row = NULL;
	GtkListBox* _tmp0_;
	gint _tmp1_;
	GtkListBoxRow* _tmp2_;
	DragListRow* _tmp3_;
	gint hover_row_middle = 0;
	DragListRow* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 507 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 508 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 508 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = y;
#line 508 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = gtk_list_box_get_row_at_y (_tmp0_, _tmp1_);
#line 508 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DRAG_LIST_ROW, DragListRow));
#line 508 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	row = _tmp3_;
#line 509 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = row;
#line 509 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = drag_list_get_widget_middle (self, (GtkWidget*) _tmp4_);
#line 509 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	hover_row_middle = _tmp5_;
#line 511 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp6_ = y;
#line 511 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp7_ = hover_row_middle;
#line 511 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp6_ < _tmp7_) {
#line 2135 "DragList.c"
		DragListRow* _tmp8_;
		DragListRow* _tmp9_;
		DragListRow* _tmp10_;
		gint _tmp11_;
		DragListRow* _tmp12_;
		gint _tmp13_;
		DragListRow* _tmp14_;
#line 512 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp8_ = row;
#line 512 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 512 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (self->priv->hover_row_bottom);
#line 512 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->hover_row_bottom = _tmp9_;
#line 513 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp10_ = row;
#line 513 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp11_ = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp10_);
#line 513 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp12_ = drag_list_get_row_at_index (self, _tmp11_ - 1);
#line 513 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (self->priv->hover_row_top);
#line 513 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->hover_row_top = _tmp12_;
#line 514 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp13_ = hover_row_middle;
#line 514 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->current_hover_range.max = _tmp13_;
#line 515 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp14_ = self->priv->hover_row_top;
#line 515 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp14_ != NULL) {
#line 2169 "DragList.c"
			DragListRow* _tmp15_;
			gint _tmp16_;
#line 516 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp15_ = self->priv->hover_row_top;
#line 516 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp16_ = drag_list_get_widget_middle (self, (GtkWidget*) _tmp15_);
#line 516 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			self->priv->current_hover_range.min = _tmp16_;
#line 2178 "DragList.c"
		} else {
			IntRange _tmp17_;
			gint _tmp18_;
#line 518 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp17_ = self->priv->input_range;
#line 518 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp18_ = _tmp17_.min;
#line 518 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			self->priv->current_hover_range.min = _tmp18_;
#line 2188 "DragList.c"
		}
	} else {
		DragListRow* _tmp19_;
		DragListRow* _tmp20_;
		DragListRow* _tmp21_;
		gint _tmp22_;
		DragListRow* _tmp23_;
		gint _tmp24_;
		DragListRow* _tmp25_;
#line 521 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp19_ = row;
#line 521 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp20_ = _g_object_ref0 (_tmp19_);
#line 521 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (self->priv->hover_row_top);
#line 521 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->hover_row_top = _tmp20_;
#line 522 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp21_ = row;
#line 522 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp22_ = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp21_);
#line 522 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp23_ = drag_list_get_row_at_index (self, _tmp22_ + 1);
#line 522 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (self->priv->hover_row_bottom);
#line 522 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->hover_row_bottom = _tmp23_;
#line 523 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp24_ = hover_row_middle;
#line 523 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->current_hover_range.min = _tmp24_;
#line 524 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp25_ = self->priv->hover_row_bottom;
#line 524 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp25_ != NULL) {
#line 2224 "DragList.c"
			DragListRow* _tmp26_;
			gint _tmp27_;
#line 525 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp26_ = self->priv->hover_row_bottom;
#line 525 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp27_ = drag_list_get_widget_middle (self, (GtkWidget*) _tmp26_);
#line 525 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			self->priv->current_hover_range.max = _tmp27_;
#line 2233 "DragList.c"
		} else {
			IntRange _tmp28_;
			gint _tmp29_;
#line 527 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp28_ = self->priv->input_range;
#line 527 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp29_ = _tmp28_.max;
#line 527 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			self->priv->current_hover_range.max = _tmp29_;
#line 2243 "DragList.c"
		}
	}
#line 507 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (row);
#line 2248 "DragList.c"
}


static void drag_list_remove_hover_style (DragList* self) {
	DragListRow* _tmp0_;
	DragListRow* _tmp3_;
#line 532 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 533 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->hover_row_top;
#line 533 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 2261 "DragList.c"
		DragListRow* _tmp1_;
		GtkStyleContext* _tmp2_;
#line 534 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = self->priv->hover_row_top;
#line 534 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 534 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_style_context_remove_class (_tmp2_, "drag-hover-top");
#line 2270 "DragList.c"
	}
#line 536 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = self->priv->hover_row_bottom;
#line 536 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp3_ != NULL) {
#line 2276 "DragList.c"
		DragListRow* _tmp4_;
		GtkStyleContext* _tmp5_;
#line 537 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = self->priv->hover_row_bottom;
#line 537 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 537 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_style_context_remove_class (_tmp5_, "drag-hover-bottom");
#line 2285 "DragList.c"
	}
}


static void drag_list_add_hover_style (DragList* self) {
	DragListRow* _tmp0_;
	DragListRow* _tmp3_;
#line 541 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 542 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->hover_row_top;
#line 542 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 2299 "DragList.c"
		DragListRow* _tmp1_;
		GtkStyleContext* _tmp2_;
#line 543 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = self->priv->hover_row_top;
#line 543 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 543 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_style_context_add_class (_tmp2_, "drag-hover-top");
#line 2308 "DragList.c"
	}
#line 545 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = self->priv->hover_row_bottom;
#line 545 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp3_ != NULL) {
#line 2314 "DragList.c"
		DragListRow* _tmp4_;
		GtkStyleContext* _tmp5_;
#line 546 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = self->priv->hover_row_bottom;
#line 546 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 546 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_style_context_add_class (_tmp5_, "drag-hover-bottom");
#line 2323 "DragList.c"
	}
}


static void drag_list_on_list_drag_leave (DragList* self, GdkDragContext* context, guint time_) {
#line 550 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 550 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (context != NULL);
#line 551 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->should_scroll = FALSE;
#line 552 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->ranges_set = FALSE;
#line 553 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_remove_hover_style (self);
#line 2339 "DragList.c"
}


static void drag_list_check_scroll (DragList* self, gint y) {
	GtkAdjustment* adjustment = NULL;
	GtkListBox* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	gdouble adjustment_min = 0.0;
	GtkAdjustment* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble adjustment_max = 0.0;
	GtkAdjustment* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble show_min = 0.0;
	gint _tmp11_;
	gdouble _tmp12_;
	gdouble show_max = 0.0;
	GtkAdjustment* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gint _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
#line 556 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 557 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 557 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_adjustment (_tmp0_);
#line 557 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 557 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	adjustment = _tmp2_;
#line 558 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = adjustment;
#line 558 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp3_ == NULL) {
#line 559 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->should_scroll = FALSE;
#line 560 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (adjustment);
#line 560 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		return;
#line 2389 "DragList.c"
	}
#line 562 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = adjustment;
#line 562 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = gtk_adjustment_get_value (_tmp4_);
#line 562 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp6_ = _tmp5_;
#line 562 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	adjustment_min = _tmp6_;
#line 563 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp7_ = adjustment;
#line 563 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp8_ = gtk_adjustment_get_page_size (_tmp7_);
#line 563 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp9_ = _tmp8_;
#line 563 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp10_ = adjustment_min;
#line 563 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	adjustment_max = _tmp9_ + _tmp10_;
#line 564 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp11_ = y;
#line 564 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp12_ = MAX ((gdouble) 0, (gdouble) (_tmp11_ - DRAG_LIST_SCROLL_DISTANCE));
#line 564 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	show_min = _tmp12_;
#line 565 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp13_ = adjustment;
#line 565 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp14_ = gtk_adjustment_get_upper (_tmp13_);
#line 565 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp15_ = _tmp14_;
#line 565 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp16_ = y;
#line 565 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp17_ = MIN (_tmp15_, (gdouble) (_tmp16_ + DRAG_LIST_SCROLL_DISTANCE));
#line 565 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	show_max = _tmp17_;
#line 566 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp18_ = adjustment_min;
#line 566 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp19_ = show_min;
#line 566 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp18_ > _tmp19_) {
#line 567 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->should_scroll = TRUE;
#line 568 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->scroll_up = TRUE;
#line 2437 "DragList.c"
	} else {
		gdouble _tmp20_;
		gdouble _tmp21_;
#line 569 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp20_ = adjustment_max;
#line 569 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp21_ = show_max;
#line 569 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp20_ < _tmp21_) {
#line 570 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			self->priv->should_scroll = TRUE;
#line 571 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			self->priv->scroll_up = FALSE;
#line 2451 "DragList.c"
		} else {
#line 573 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			self->priv->should_scroll = FALSE;
#line 2455 "DragList.c"
		}
	}
#line 556 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (adjustment);
#line 2460 "DragList.c"
}


static gboolean drag_list_scroll (DragList* self) {
	gboolean result = FALSE;
	GtkAdjustment* adjustment = NULL;
	GtkListBox* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp13_;
#line 577 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 578 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 578 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_adjustment (_tmp0_);
#line 578 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 578 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	adjustment = _tmp2_;
#line 579 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = self->priv->should_scroll;
#line 579 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp3_) {
#line 2486 "DragList.c"
		gboolean _tmp4_;
#line 580 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = self->priv->scroll_up;
#line 580 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp4_) {
#line 2492 "DragList.c"
			GtkAdjustment* _tmp5_;
			GtkAdjustment* _tmp6_;
			gdouble _tmp7_;
			gdouble _tmp8_;
#line 581 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp5_ = adjustment;
#line 581 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp6_ = adjustment;
#line 581 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp7_ = gtk_adjustment_get_value (_tmp6_);
#line 581 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp8_ = _tmp7_;
#line 581 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			gtk_adjustment_set_value (_tmp6_, _tmp8_ - DRAG_LIST_SCROLL_STEP_SIZE);
#line 2507 "DragList.c"
		} else {
			GtkAdjustment* _tmp9_;
			GtkAdjustment* _tmp10_;
			gdouble _tmp11_;
			gdouble _tmp12_;
#line 583 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp9_ = adjustment;
#line 583 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp10_ = adjustment;
#line 583 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp11_ = gtk_adjustment_get_value (_tmp10_);
#line 583 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp12_ = _tmp11_;
#line 583 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			gtk_adjustment_set_value (_tmp10_, _tmp12_ + DRAG_LIST_SCROLL_STEP_SIZE);
#line 2523 "DragList.c"
		}
	} else {
#line 586 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		self->priv->scrolling = FALSE;
#line 2528 "DragList.c"
	}
#line 588 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp13_ = self->priv->should_scroll;
#line 588 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp13_;
#line 588 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (adjustment);
#line 588 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 2538 "DragList.c"
}


static void drag_list_on_list_drag_data_received (DragList* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_) {
	DragListRow* row = NULL;
	gint index = 0;
	DragListRow* _tmp0_;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
#line 591 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 591 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (context != NULL);
#line 591 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (selection_data != NULL);
#line 597 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	index = -1;
#line 598 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_remove_hover_style (self);
#line 599 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->hover_row_bottom;
#line 599 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 2562 "DragList.c"
		DragListRow* _tmp1_;
		gint _tmp2_;
#line 600 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = self->priv->hover_row_bottom;
#line 600 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp1_);
#line 600 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		index = _tmp2_;
#line 2571 "DragList.c"
	} else {
		DragListRow* _tmp3_;
#line 601 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp3_ = self->priv->hover_row_top;
#line 601 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp3_ != NULL) {
#line 2578 "DragList.c"
			DragListRow* _tmp4_;
			gint _tmp5_;
#line 602 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp4_ = self->priv->hover_row_top;
#line 602 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp5_ = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp4_);
#line 602 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			index = _tmp5_ + 1;
#line 2587 "DragList.c"
		} else {
			GtkListBox* _tmp6_;
			GtkListBoxRow* _tmp7_;
#line 603 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp6_ = self->priv->listbox;
#line 603 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp7_ = gtk_list_box_get_row_at_index (_tmp6_, 0);
#line 603 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			if (_tmp7_ == NULL) {
#line 604 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
				index = 0;
#line 2599 "DragList.c"
			}
		}
	}
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp9_ = index;
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp9_ >= 0) {
#line 2607 "DragList.c"
		GtkSelectionData* _tmp10_;
		GdkAtom _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp10_ = selection_data;
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp11_ = gtk_selection_data_get_data_type (_tmp10_);
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp12_ = gdk_atom_name (_tmp11_);
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp13_ = _tmp12_;
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp8_ = g_strcmp0 (_tmp13_, "DRAG_LIST_ROW") == 0;
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_free0 (_tmp13_);
#line 2624 "DragList.c"
	} else {
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp8_ = FALSE;
#line 2628 "DragList.c"
	}
#line 606 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp8_) {
#line 2632 "DragList.c"
		GtkSelectionData* _tmp14_;
		guchar* _tmp15_;
		DragListRow* _tmp16_;
		DragListRow* _tmp17_;
		DragListRow* _tmp18_;
		gint _tmp19_;
#line 607 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp14_ = selection_data;
#line 607 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp15_ = gtk_selection_data_get_data (_tmp14_);
#line 607 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp16_ = ((DragListRow**) _tmp15_)[0];
#line 607 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 607 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (row);
#line 607 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		row = _tmp17_;
#line 608 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp18_ = row;
#line 608 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp19_ = index;
#line 608 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_drag_insert_row (self, _tmp18_, _tmp19_);
#line 2657 "DragList.c"
	}
#line 610 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->drag_row);
#line 610 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->drag_row = NULL;
#line 611 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_top);
#line 611 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->hover_row_top = NULL;
#line 612 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_bottom);
#line 612 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->hover_row_bottom = NULL;
#line 613 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->ranges_set = FALSE;
#line 591 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (row);
#line 2675 "DragList.c"
}


static void drag_list_drag_insert_row (DragList* self, DragListRow* row, gint index) {
	DragList* row_draglist = NULL;
	DragListRow* _tmp0_;
	DragList* _tmp1_;
	DragList* _tmp2_;
	DragList* _tmp3_;
#line 616 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 616 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 617 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = row;
#line 617 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = drag_list_row_get_drag_list_box (_tmp0_);
#line 617 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 617 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	row_draglist = _tmp2_;
#line 619 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = row_draglist;
#line 619 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp3_ == self) {
#line 2701 "DragList.c"
		DragListRow* _tmp4_;
		gint _tmp5_;
#line 620 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = row;
#line 620 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp5_ = index;
#line 620 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_drag_list_move_row (self, _tmp4_, _tmp5_, TRUE);
#line 2710 "DragList.c"
	} else {
		gboolean _tmp6_ = FALSE;
		DragListModel* _tmp7_;
#line 622 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp7_ = self->model;
#line 622 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp7_ == NULL) {
#line 2718 "DragList.c"
			DragList* _tmp8_;
			DragListModel* _tmp9_;
#line 622 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp8_ = row_draglist;
#line 622 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp9_ = _tmp8_->model;
#line 622 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp6_ = _tmp9_ == NULL;
#line 2727 "DragList.c"
		} else {
#line 622 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp6_ = FALSE;
#line 2731 "DragList.c"
		}
#line 622 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		if (_tmp6_) {
#line 2735 "DragList.c"
			DragListRow* _tmp10_;
			GtkContainer* _tmp11_;
			DragListRow* _tmp12_;
			GtkListBox* _tmp13_;
			DragListRow* _tmp14_;
			gint _tmp15_;
#line 623 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp10_ = row;
#line 623 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp11_ = (GtkContainer*) gtk_widget_get_parent ((GtkWidget*) _tmp10_);
#line 623 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp12_ = row;
#line 623 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			gtk_container_remove (_tmp11_, (GtkWidget*) _tmp12_);
#line 624 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp13_ = self->priv->listbox;
#line 624 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp14_ = row;
#line 624 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp15_ = index;
#line 624 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			gtk_list_box_insert (_tmp13_, (GtkWidget*) _tmp14_, _tmp15_);
#line 2758 "DragList.c"
		} else {
			DragListRow* _tmp16_;
			gint _tmp17_;
#line 626 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp16_ = row;
#line 626 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			_tmp17_ = index;
#line 626 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
			g_signal_emit (self, drag_list_signals[DRAG_LIST_ROW_RECEIVED_WITH_MODEL_SIGNAL], 0, _tmp16_, _tmp17_);
#line 2768 "DragList.c"
		}
	}
#line 616 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (row_draglist);
#line 2773 "DragList.c"
}


GtkAdjustment* drag_list_get_vadjustment (DragList* self) {
	GtkAdjustment* result;
	GtkListBox* _tmp0_;
	GtkAdjustment* _tmp1_;
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_adjustment (_tmp0_);
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp1_;
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 2791 "DragList.c"
}


void drag_list_set_vadjustment (DragList* self, GtkAdjustment* value) {
	GtkListBox* _tmp0_;
	GtkAdjustment* _tmp1_;
#line 59 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = value;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_list_box_set_adjustment (_tmp0_, _tmp1_);
#line 59 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_object_notify_by_pspec ((GObject *) self, drag_list_properties[DRAG_LIST_VADJUSTMENT_PROPERTY]);
#line 2808 "DragList.c"
}


static void drag_list_real_activate_cursor_row (DragList* self) {
	GtkListBox* _tmp0_;
#line 68 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 68 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_emit_by_name (_tmp0_, "activate-cursor-row");
#line 2818 "DragList.c"
}


static void drag_list_real_row_activated (DragList* self, DragListRow* row) {
#line 75 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 76 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return;
#line 2827 "DragList.c"
}


static void drag_list_real_move_cursor (DragList* self, GtkMovementStep step, gint count) {
	GtkListBox* _tmp0_;
	GtkMovementStep _tmp1_;
	gint _tmp2_;
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->internal_signal = TRUE;
#line 88 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 88 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = step;
#line 88 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = count;
#line 88 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_emit_by_name (_tmp0_, "move-cursor", _tmp1_, _tmp2_);
#line 2845 "DragList.c"
}


static void g_cclosure_user_marshal_VOID__ENUM_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ENUM_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		data1 = closure->data;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		data2 = param_values->data[0].v_pointer;
#line 2864 "DragList.c"
	} else {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		data2 = closure->data;
#line 2870 "DragList.c"
	}
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	callback = (GMarshalFunc_VOID__ENUM_INT) (marshal_data ? marshal_data : cc->callback);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2876 "DragList.c"
}


static void drag_list_real_row_selected (DragList* self, DragListRow* row) {
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return;
#line 2883 "DragList.c"
}


static void drag_list_real_row_received_with_model (DragList* self, DragListRow* row, gint index) {
#line 118 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 119 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return;
#line 2892 "DragList.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		data1 = closure->data;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		data2 = param_values->data[0].v_pointer;
#line 2911 "DragList.c"
	} else {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		data2 = closure->data;
#line 2917 "DragList.c"
	}
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2923 "DragList.c"
}


static void drag_list_class_init (DragListClass * klass) {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_parent_class = g_type_class_peek_parent (klass);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_type_class_add_private (klass, sizeof (DragListPrivate));
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	((DragListClass *) klass)->activate_cursor_row = drag_list_real_activate_cursor_row;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	((DragListClass *) klass)->row_activated = drag_list_real_row_activated;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	((DragListClass *) klass)->move_cursor = drag_list_real_move_cursor;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	((DragListClass *) klass)->row_selected = drag_list_real_row_selected;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	((DragListClass *) klass)->row_received_with_model = drag_list_real_row_received_with_model;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_drag_list_get_property;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_drag_list_set_property;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	G_OBJECT_CLASS (klass)->finalize = drag_list_finalize;
#line 2948 "DragList.c"
	/**
	     * Adjustment used for scrolling.
	     */
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRAG_LIST_VADJUSTMENT_PROPERTY, drag_list_properties[DRAG_LIST_VADJUSTMENT_PROPERTY] = g_param_spec_object ("vadjustment", "vadjustment", "vadjustment", gtk_adjustment_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2954 "DragList.c"
	/**
	     * Activates the currently selected row.
	     */
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_ACTIVATE_CURSOR_ROW_SIGNAL] = g_signal_new ("activate-cursor-row", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, activate_cursor_row), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2960 "DragList.c"
	/**
	     * The row_activated signal is emitted when a row has been activated by the.
	     * user.
	     */
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_ROW_ACTIVATED_SIGNAL] = g_signal_new ("row-activated", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, row_activated), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DRAG_LIST_ROW);
#line 2967 "DragList.c"
	/**
	     * Selects the row count*step positions away from the currently selected row.
	     */
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_MOVE_CURSOR_SIGNAL] = g_signal_new ("move-cursor", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, move_cursor), NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_INT, G_TYPE_NONE, 2, GTK_TYPE_MOVEMENT_STEP, G_TYPE_INT);
#line 2973 "DragList.c"
	/**
	     * The row_selected signal is emitted when a new row is selected, or null.
	     * when the last row is removed.
	     */
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_ROW_SELECTED_SIGNAL] = g_signal_new ("row-selected", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, row_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DRAG_LIST_ROW);
#line 2980 "DragList.c"
	/**
	     * The row_received_with_model is emitted when this receives a row when a
	     * model is bound to this or to the current parent DragList of the row.
	     *
	     * @param row Row that was received
	     * @param index index at which it would have been inserted in
	     */
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_ROW_RECEIVED_WITH_MODEL_SIGNAL] = g_signal_new ("row-received-with-model", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, row_received_with_model), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, TYPE_DRAG_LIST_ROW, G_TYPE_INT);
#line 2990 "DragList.c"
}


static void drag_list_instance_init (DragList * self) {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv = DRAG_LIST_GET_PRIVATE (self);
#line 34 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->should_scroll = FALSE;
#line 35 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->scrolling = FALSE;
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->ranges_set = FALSE;
#line 3003 "DragList.c"
}


static void drag_list_finalize (GObject * obj) {
	DragList * self;
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DRAG_LIST, DragList);
#line 26 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->listbox);
#line 28 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->model);
#line 29 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	(self->priv->create_widget_func_target_destroy_notify == NULL) ? NULL : (self->priv->create_widget_func_target_destroy_notify (self->priv->create_widget_func_target), NULL);
#line 29 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func = NULL;
#line 29 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func_target = NULL;
#line 29 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->create_widget_func_target_destroy_notify = NULL;
#line 31 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_top);
#line 32 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_bottom);
#line 33 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->drag_row);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	G_OBJECT_CLASS (drag_list_parent_class)->finalize (obj);
#line 3031 "DragList.c"
}


/**
 * A Gtk.ListBox based widget with drag and drop support.
 *
 * If this contains any rows exactly one will be selected at all times.
 *
 * Row headers are not supported.
 */
GType drag_list_get_type (void) {
	static volatile gsize drag_list_type_id__volatile = 0;
	if (g_once_init_enter (&drag_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DragListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drag_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DragList), 0, (GInstanceInitFunc) drag_list_instance_init, NULL };
		GType drag_list_type_id;
		drag_list_type_id = g_type_register_static (gtk_bin_get_type (), "DragList", &g_define_type_info, 0);
		g_once_init_leave (&drag_list_type_id__volatile, drag_list_type_id);
	}
	return drag_list_type_id__volatile;
}


static void _vala_drag_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DragList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DRAG_LIST, DragList);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	switch (property_id) {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		case DRAG_LIST_VADJUSTMENT_PROPERTY:
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		g_value_set_object (value, drag_list_get_vadjustment (self));
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		break;
#line 3065 "DragList.c"
		default:
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		break;
#line 3071 "DragList.c"
	}
}


static void _vala_drag_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DragList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DRAG_LIST, DragList);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	switch (property_id) {
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		case DRAG_LIST_VADJUSTMENT_PROPERTY:
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		drag_list_set_vadjustment (self, g_value_get_object (value));
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		break;
#line 3087 "DragList.c"
		default:
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		break;
#line 3093 "DragList.c"
	}
}


inline gboolean int_range_contains (IntRange *self, gint val) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = val;
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = (*self).min;
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp1_ >= _tmp2_) {
#line 3109 "DragList.c"
		gint _tmp3_;
		gint _tmp4_;
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp3_ = val;
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = (*self).max;
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp0_ = _tmp3_ <= _tmp4_;
#line 3118 "DragList.c"
	} else {
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp0_ = FALSE;
#line 3122 "DragList.c"
	}
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp0_;
#line 642 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 3128 "DragList.c"
}


inline gint int_range_clamp (IntRange *self, gint val) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 643 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = val;
#line 643 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = (*self).min;
#line 643 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = (*self).max;
#line 643 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = CLAMP (_tmp0_, _tmp1_, _tmp2_);
#line 643 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp3_;
#line 643 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 3150 "DragList.c"
}


IntRange* int_range_dup (const IntRange* self) {
	IntRange* dup;
#line 639 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	dup = g_new0 (IntRange, 1);
#line 639 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	memcpy (dup, self, sizeof (IntRange));
#line 639 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return dup;
#line 3162 "DragList.c"
}


void int_range_free (IntRange* self) {
#line 639 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_free (self);
#line 3169 "DragList.c"
}


GType int_range_get_type (void) {
	static volatile gsize int_range_type_id__volatile = 0;
	if (g_once_init_enter (&int_range_type_id__volatile)) {
		GType int_range_type_id;
		int_range_type_id = g_boxed_type_register_static ("IntRange", (GBoxedCopyFunc) int_range_dup, (GBoxedFreeFunc) int_range_free);
		g_once_init_leave (&int_range_type_id__volatile, int_range_type_id);
	}
	return int_range_type_id__volatile;
}


static void _drag_list_row_handle_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender, GdkDragContext* context, gpointer self) {
#line 667 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_row_handle_drag_begin ((DragListRow*) self, context);
#line 3187 "DragList.c"
}


static void _drag_list_row_handle_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender, GdkDragContext* context, GtkSelectionData* selection_data, guint info, guint time_, gpointer self) {
#line 668 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_row_handle_drag_data_get ((DragListRow*) self, context, selection_data, info, time_);
#line 3194 "DragList.c"
}


DragListRow* drag_list_row_construct (GType object_type) {
	DragListRow * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkImage* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkImage* _tmp7_;
	GtkBox* _tmp8_;
	GtkEventBox* _tmp9_;
	GtkEventBox* _tmp10_;
	GtkEventBox* _tmp11_;
	GtkEventBox* _tmp12_;
#line 653 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self = (DragListRow*) g_object_new (object_type, NULL);
#line 654 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 5);
#line 654 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_object_ref_sink (_tmp0_);
#line 654 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->layout);
#line 654 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->layout = _tmp0_;
#line 655 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = self->priv->layout;
#line 655 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp1_, 5);
#line 656 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = self->priv->layout;
#line 656 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp2_, 5);
#line 657 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = self->priv->layout;
#line 657 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
#line 659 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = (GtkEventBox*) gtk_event_box_new ();
#line 659 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_object_ref_sink (_tmp4_);
#line 659 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->handle);
#line 659 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->handle = _tmp4_;
#line 660 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("view-list-symbolic", GTK_ICON_SIZE_MENU);
#line 660 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_object_ref_sink (_tmp5_);
#line 660 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->image);
#line 660 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->image = _tmp5_;
#line 661 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp6_ = self->priv->handle;
#line 661 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp7_ = self->priv->image;
#line 661 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 662 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp8_ = self->priv->layout;
#line 662 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp9_ = self->priv->handle;
#line 662 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_box_pack_end (_tmp8_, (GtkWidget*) _tmp9_, FALSE, TRUE, (guint) 0);
#line 664 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp10_ = self->priv->handle;
#line 664 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_drag_source_set ((GtkWidget*) _tmp10_, GDK_BUTTON1_MASK, dlb_entries, G_N_ELEMENTS (dlb_entries), GDK_ACTION_MOVE);
#line 667 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp11_ = self->priv->handle;
#line 667 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp11_, "drag-begin", (GCallback) _drag_list_row_handle_drag_begin_gtk_widget_drag_begin, self, 0);
#line 668 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp12_ = self->priv->handle;
#line 668 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp12_, "drag-data-get", (GCallback) _drag_list_row_handle_drag_data_get_gtk_widget_drag_data_get, self, 0);
#line 653 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return self;
#line 3277 "DragList.c"
}


DragListRow* drag_list_row_new (void) {
#line 653 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return drag_list_row_construct (TYPE_DRAG_LIST_ROW);
#line 3284 "DragList.c"
}


void drag_list_row_set_start_widget (DragListRow* self, GtkWidget* widget) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
#line 671 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 672 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->start_widget;
#line 672 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 3299 "DragList.c"
		GtkBox* _tmp1_;
		GtkWidget* _tmp2_;
#line 673 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = self->priv->layout;
#line 673 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = self->priv->start_widget;
#line 673 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp1_, _tmp2_);
#line 3308 "DragList.c"
	}
#line 675 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = widget;
#line 675 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 675 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->start_widget);
#line 675 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->start_widget = _tmp4_;
#line 676 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = self->priv->start_widget;
#line 676 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp5_ != NULL) {
#line 3322 "DragList.c"
		GtkBox* _tmp6_;
		GtkWidget* _tmp7_;
#line 677 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp6_ = self->priv->layout;
#line 677 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp7_ = self->priv->start_widget;
#line 677 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_box_pack_start (_tmp6_, _tmp7_, FALSE, TRUE, (guint) 0);
#line 3331 "DragList.c"
	}
}


GtkWidget* drag_list_row_get_start_widget (DragListRow* self) {
	GtkWidget* result = NULL;
	GtkWidget* _tmp0_;
#line 681 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 682 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->start_widget;
#line 682 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp0_;
#line 682 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 3347 "DragList.c"
}


void drag_list_row_set_center_widget (DragListRow* self, GtkWidget* widget) {
	GtkWidget* _tmp0_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
#line 685 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 686 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->center_widget;
#line 686 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 3362 "DragList.c"
		GtkBox* _tmp1_;
		GtkWidget* _tmp2_;
#line 687 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp1_ = self->priv->layout;
#line 687 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp2_ = self->priv->start_widget;
#line 687 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp1_, _tmp2_);
#line 3371 "DragList.c"
	}
#line 689 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = widget;
#line 689 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 689 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->center_widget);
#line 689 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv->center_widget = _tmp4_;
#line 690 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = self->priv->center_widget;
#line 690 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp5_ != NULL) {
#line 3385 "DragList.c"
		GtkBox* _tmp6_;
		GtkWidget* _tmp7_;
		GtkBox* _tmp8_;
		GtkWidget* _tmp9_;
#line 691 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp6_ = self->priv->layout;
#line 691 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp7_ = self->priv->center_widget;
#line 691 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_box_set_center_widget (_tmp6_, _tmp7_);
#line 692 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp8_ = self->priv->layout;
#line 692 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp9_ = self->priv->center_widget;
#line 692 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		gtk_box_set_child_packing (_tmp8_, _tmp9_, TRUE, TRUE, (guint) 0, GTK_PACK_START);
#line 3402 "DragList.c"
	}
}


GtkWidget* drag_list_row_get_center_widget (DragListRow* self) {
	GtkWidget* result = NULL;
	GtkWidget* _tmp0_;
#line 698 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 699 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = self->priv->center_widget;
#line 699 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = _tmp0_;
#line 699 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 3418 "DragList.c"
}


/**
     * Gets the DragList parent of this.
     */
DragList* drag_list_row_get_drag_list_box (DragListRow* self) {
	DragList* result = NULL;
	GtkWidget* parent = NULL;
	GtkContainer* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
#line 705 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 706 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = (GtkContainer*) gtk_widget_get_parent ((GtkWidget*) self);
#line 706 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 706 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	parent = _tmp1_;
#line 707 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = parent;
#line 707 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp2_ != NULL) {
#line 3443 "DragList.c"
		GtkWidget* _tmp3_;
		GtkContainer* _tmp4_;
#line 708 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp3_ = parent;
#line 708 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp4_ = (GtkContainer*) gtk_widget_get_parent (_tmp3_);
#line 708 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, TYPE_DRAG_LIST) ? ((DragList*) _tmp4_) : NULL;
#line 708 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (parent);
#line 708 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		return result;
#line 3456 "DragList.c"
	}
#line 710 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	result = NULL;
#line 710 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (parent);
#line 710 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	return result;
#line 3464 "DragList.c"
}


static void drag_list_row_handle_drag_begin (DragListRow* self, GdkDragContext* context) {
	DragList* draglist = NULL;
	GtkAllocation alloc = {0};
	cairo_surface_t* surface = NULL;
	cairo_t* cr = NULL;
	gint x = 0;
	gint y = 0;
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	gint _tmp2_;
	GtkAllocation _tmp3_;
	gint _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_surface_t* _tmp6_;
	cairo_t* _tmp7_;
	DragList* _tmp8_;
	DragList* _tmp9_;
	DragList* _tmp10_;
	GtkStyleContext* _tmp13_;
	cairo_t* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkEventBox* _tmp16_;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	cairo_surface_t* _tmp19_;
	GdkDragContext* _tmp20_;
	cairo_surface_t* _tmp21_;
#line 713 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 713 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (context != NULL);
#line 720 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 720 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	alloc = _tmp0_;
#line 721 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = alloc;
#line 721 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = _tmp1_.width;
#line 721 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = alloc;
#line 721 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = _tmp3_.height;
#line 721 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp5_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp2_, _tmp4_);
#line 721 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_cairo_surface_destroy0 (surface);
#line 721 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	surface = _tmp5_;
#line 724 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp6_ = surface;
#line 724 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp7_ = cairo_create (_tmp6_);
#line 724 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_cairo_destroy0 (cr);
#line 724 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	cr = _tmp7_;
#line 726 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp8_ = drag_list_row_get_drag_list_box (self);
#line 726 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 726 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (draglist);
#line 726 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	draglist = _tmp9_;
#line 727 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp10_ = draglist;
#line 727 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	if (_tmp10_ != NULL) {
#line 3537 "DragList.c"
		DragList* _tmp11_;
		DragListRow* _tmp12_;
#line 728 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp11_ = draglist;
#line 728 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp12_ = _g_object_ref0 (self);
#line 728 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_g_object_unref0 (_tmp11_->drag_row);
#line 728 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
		_tmp11_->drag_row = _tmp12_;
#line 3548 "DragList.c"
	}
#line 730 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 730 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_style_context_add_class (_tmp13_, "drag-icon");
#line 731 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp14_ = cr;
#line 731 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_draw ((GtkWidget*) self, _tmp14_);
#line 732 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 732 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_style_context_remove_class (_tmp15_, "drag-icon");
#line 734 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp16_ = self->priv->handle;
#line 734 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_widget_translate_coordinates ((GtkWidget*) _tmp16_, (GtkWidget*) self, 0, 0, &_tmp17_, &_tmp18_);
#line 734 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	x = _tmp17_;
#line 734 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	y = _tmp18_;
#line 735 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp19_ = surface;
#line 735 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	cairo_surface_set_device_offset (_tmp19_, (gdouble) (-x), (gdouble) (-y));
#line 736 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp20_ = context;
#line 736 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp21_ = surface;
#line 736 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_drag_set_icon_surface (_tmp20_, _tmp21_);
#line 713 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_cairo_destroy0 (cr);
#line 713 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_cairo_surface_destroy0 (surface);
#line 713 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (draglist);
#line 3586 "DragList.c"
}


static void drag_list_row_handle_drag_data_get (DragListRow* self, GdkDragContext* context, GtkSelectionData* selection_data, guint info, guint time_) {
	guchar* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkSelectionData* _tmp3_;
	GdkAtom _tmp4_;
#line 739 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 739 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (context != NULL);
#line 739 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_return_if_fail (selection_data != NULL);
#line 743 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp0_ = g_new0 (guchar, sizeof (GtkWidget*));
#line 743 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	data = _tmp0_;
#line 743 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	data_length1 = sizeof (GtkWidget*);
#line 743 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_data_size_ = data_length1;
#line 744 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) self);
#line 744 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (((GtkWidget**) data)[0]);
#line 744 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	((GtkWidget**) data)[0] = _tmp1_;
#line 744 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp2_ = ((GtkWidget**) data)[0];
#line 745 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp3_ = selection_data;
#line 745 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_tmp4_ = gdk_atom_intern_static_string ("DRAG_LIST_ROW");
#line 745 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	gtk_selection_data_set (_tmp3_, _tmp4_, 32, data, data_length1);
#line 739 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	data = (g_free (data), NULL);
#line 3629 "DragList.c"
}


static void drag_list_row_class_init (DragListRowClass * klass) {
#line 646 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	drag_list_row_parent_class = g_type_class_peek_parent (klass);
#line 646 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	g_type_class_add_private (klass, sizeof (DragListRowPrivate));
#line 646 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	G_OBJECT_CLASS (klass)->finalize = drag_list_row_finalize;
#line 3640 "DragList.c"
}


static void drag_list_row_instance_init (DragListRow * self) {
#line 646 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self->priv = DRAG_LIST_ROW_GET_PRIVATE (self);
#line 3647 "DragList.c"
}


static void drag_list_row_finalize (GObject * obj) {
	DragListRow * self;
#line 646 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DRAG_LIST_ROW, DragListRow);
#line 647 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->handle);
#line 648 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->layout);
#line 649 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->image);
#line 650 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->start_widget);
#line 651 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	_g_object_unref0 (self->priv->center_widget);
#line 646 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/view/DragList.vala"
	G_OBJECT_CLASS (drag_list_row_parent_class)->finalize (obj);
#line 3667 "DragList.c"
}


GType drag_list_row_get_type (void) {
	static volatile gsize drag_list_row_type_id__volatile = 0;
	if (g_once_init_enter (&drag_list_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DragListRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drag_list_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DragListRow), 0, (GInstanceInitFunc) drag_list_row_instance_init, NULL };
		GType drag_list_row_type_id;
		drag_list_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "DragListRow", &g_define_type_info, 0);
		g_once_init_leave (&drag_list_row_type_id__volatile, drag_list_row_type_id);
	}
	return drag_list_row_type_id__volatile;
}



